function main(inpargs)

_userid = subwrd(inpargs,1)

'reinit'

_filedir = "/net/tpm/gfdl/xcplot/"
stormfile = _filedir%"storms_6th.inp"

'set rgb 17 230 230 230'
_lastgraph = "clear"
_defcint   = 2
_vecspcing = 0.3
_grdspcing = 0.5
_grdsigdig = 2
_grddigsiz = 0.06
*_waittime  = 250
_waittime  = 1000
_loopsp    = 3
_trakopt   = notrak
_tempunit  = "degf"
_prcpunit  = "inches"
_windunit  = "knots"
_dispvar   = "none"
_fileflag  = "closed"
_displev   = 500
_dispopt   = "clearplot"
_gxplottyp = "contour"
_gxwindtyp = "vector"
_trakread  = "notyet"
_outerdens = 1
_innerdens = 1

_inxstart_def =  1
_inxend_def   = 60
_inystart_def =  1
_inyend_def   = 60

_inxstart = _inxstart_def
_inxend   = _inxend_def
_inystart = _inystart_def
_inyend   = _inyend_def

_outvplft = 0.0
_outvprgt = 6.4
_outvpbot = 0.0
_outvptop = 8.1
_outpalft = 0.5
_outpargt = 6.3
_outpabot = 0.5
_outpatop = 7.9

_invplft = 6.5
_invprgt = 11.0
_invpbot = 0.0
_invptop = 8.1
_inpalft = 0.5
_inpargt = 4.5
_inpabot = 2.6
_inpatop = 7.6

rc = rdstorm(stormfile)
rc = filebox()
rc = readopts()
rc = readopt2()
rc = readopt3()
rc = readvpfl()

while (1)

  'clear'
  rc = initmenu()
  
  while (1)

    'q pos'

    mousenum = subwrd(result,5)
    widclass = subwrd(result,6)
    button   = subwrd(result,7)

    if (button = 1)
*     "Main" menu button
      item   = subwrd(result,8)
      choice = _filefunc.item
*      say 'item= 'item'  choice= 'choice
      if (choice = "reit")
        say "!!! Reinit selected"
        'reinit'
        _fileflag = "closed"
        _lastgraph = "clear"
        _dispvar = "none"
        rc = redomenu()
      endif
      if (choice = "clr")
*        say "!!! Clear selected"
        'clear graphics'
	_lastgraph = "clear"
        rc = redomenu()
      endif
      if (choice = "printbw" | choice = "printcl" | choice = "printgif" | choice = "printrgif" | choice = "printpng" | choice = "printrpng" )
        _hardcopy = choice
        rc = output()
      endif
      if (choice = "return")
        say "!!! Exiting script...."
        return
      endif
      if (choice = "quit")
        say "!!! Quitting GrADS...."
        quit
      endif
    endif

    if (button = 2)
*     "Storms" menu button
      item = subwrd(result,8)
      rc = openctl(item)
      rc = gettimes()
      rc = readvars()
      rc = readlevs()
      rc = redomenu()
      'set map 1 1 6'
      'set mpdset mres'
    endif

    if (button = 3)
*     "Vars" menu button
      item = subwrd(result,8)
      rc = pickvar(item)
    endif

    if (button = 4)
*     "Levs" menu button
      item = subwrd(result,8)
      rc = picklev(item)
    endif

    if (button = 5)
*     "t", or time, menu button
      item = subwrd(result,8)
      rc = picktime(item)
    endif

    if (button = 6)
*     "Opts" menu button
      item = subwrd(result,8)
      rc = pickopt(item)
    endif

    if (button = 7)
*     "Opts_2" menu button
      item = subwrd(result,8)
      rc = pickopt2(item)
    endif

    if (button = 8)
*     "Opts_3" menu button
      rc = pickopt3(result)
    endif
    
    if (button = 9)
*     "Vert_Profile" menu button
      item = subwrd(result,8)
      rc = pickvpfl(item)
    endif

    if (button = 16 | button = 17)

*     16 = step back, 17 = step forward

      _disptype = "step"

      if (_dispvar = "none" | _fileflag = "closed")
        rc = errmsgp()
        continue
      endif

      'q dims'
      rec = sublin(result,5)
      timeval = subwrd(rec,9)

      if (button = 16)
        if (timeval = 1)
          say ' '
          say '!!! *****************************************************'
          say '!!! CANNOT DISPLAY BACKWARDS: YOU ARE AT THE INITIAL TIME'
          say '!!! *****************************************************'
          say ' '
        else
          timeval = timeval - 1
          'set t 'timeval
          _inxstart = _inxstart_def
          _inxend   = _inxend_def
          _inystart = _inystart_def
          _inyend   = _inyend_def
          rc = plotvar(timeval)
          if (_trakopt = fulltrak | _trakopt = nowtrak | _trakopt = markpos)
            if (_trakread = "notyet")
              rc = readtrak()
            endif
            rc = plottrak(timeval)
          endif
        endif
      else
*        say 'button 17 forward, timeval = 'timeval
        _inxstart = _inxstart_def
        _inxend   = _inxend_def
        _inystart = _inystart_def
        _inyend   = _inyend_def
        rc = plotvar(timeval)
        if (_trakopt = fulltrak | _trakopt = nowtrak | _trakopt = markpos)
          if (_trakread = "notyet")
            rc = readtrak()
          endif
          rc = plottrak(timeval)
        endif
        if (timeval < _timemax)
          timeval = timeval + 1
          'set t 'timeval
        else
          say ' '
          say '!!! NOTE: You are now at the last forecast hour....'
          say ' '
        endif
      endif

    endif


    if (button = 18 | button = 19)

*     18 = loop back, 19 = loop forward

      _disptype = "loop"

      if (_dispvar = "none" | _fileflag = "closed")
        rc = errmsgp()
        continue
      endif

      'q dims'
      rec = sublin(result,5)
      timeval = subwrd(rec,9)

      if (button = 18)

*       loop back

        timeval = _timemax
        'set dbuff on'
        while (timeval > 1)

          'set t 'timeval
          _inxstart = _inxstart_def
          _inxend   = _inxend_def
          _inystart = _inystart_def
          _inyend   = _inyend_def
          rc = plotvar(timeval)
          if (_trakopt = fulltrak | _trakopt = nowtrak | _trakopt = markpos)
            if (_trakread = "notyet")
              rc = readtrak()
            endif
            rc = plottrak(timeval)
          endif

          swap

          timeval = timeval - 1
          if (timeval > 1)
            iwait = 1
            while (iwait < _waittime)
              'd cos(0.00001) * sqrt(10000000)'
              iwait = iwait + 1
            endwhile
          endif

        endwhile

        '!sleep 1'
        'set dbuff off'
        'set dfile 1'
        'set t 1'
        _inxstart = _inxstart_def
        _inxend   = _inxend_def
        _inystart = _inystart_def
        _inyend   = _inyend_def
        rc = plotvar(1)
        if (_trakopt = fulltrak | _trakopt = nowtrak | _trakopt = markpos)
          if (_trakread = "notyet")
            rc = readtrak()
          endif
          rc = plottrak(1)
        endif
        rc = redomenu()

      else

*       loop forward

        timeval = 1
        'set dbuff on'
        while (timeval < _timemax)

          'set t 'timeval
          _inxstart = _inxstart_def
          _inxend   = _inxend_def
          _inystart = _inystart_def
          _inyend   = _inyend_def
          rc = plotvar(timeval)
          if (_trakopt = fulltrak | _trakopt = nowtrak | _trakopt = markpos)
            if (_trakread = "notyet")
              rc = readtrak()
            endif
            rc = plottrak(timeval)
          endif

          swap

          timeval = timeval + 1
          if (timeval < _timemax)
            iwait = 1
            while (iwait < _waittime)
              'd cos(0.00001) * sqrt(10000000)'
              iwait = iwait + 1
            endwhile
          endif

        endwhile

        '!sleep 1'
        'set dbuff off'
        'set dfile 1'
        'set t '_timemax
        _inxstart = _inxstart_def
        _inxend   = _inxend_def
        _inystart = _inystart_def
        _inyend   = _inyend_def
        rc = plotvar(_timemax)
        if (_trakopt = fulltrak | _trakopt = nowtrak | _trakopt = markpos)
          if (_trakread = "notyet")
            rc = readtrak()
          endif
          rc = plottrak(_timemax)
        endif
        rc = redomenu()

      endif

    endif

    if (button = 20)
*     Set time value back to t=00h
      if (_dispvar = "none" | _fileflag = "closed")
        rc = errmsgp()
        continue
      endif
      timeval = 1
      'set dfile 1'
      'set t 'timeval
      rc = redomenu()
    endif

    if (button = 22 | button = 23)
*     Modify the speed button for automated loops
      rc = setspeed(button)
    endif


    if (button = 31)

*     Display the data for the current time but do not 
*     increment or decrement the time variable.

      _disptype = "static"

      if (_dispvar = "none" | _fileflag = "closed")
        rc = errmsgp()
        continue
      endif

      'q dims'
      rec = sublin(result,5)
      timeval = subwrd(rec,9)

      'set t 'timeval

      rc = plotvar(timeval)
      if (_trakopt = fulltrak | _trakopt = nowtrak | _trakopt = markpos)
        if (_trakread = "notyet")
          rc = readtrak()
        endif
        rc = plottrak(timeval)
      endif

    endif

  endwhile

endwhile

return

*---------------------*
*
*---------------------*
function plotvar(timeval)

* First get the correct time value from the 1/6-degree file....

  'set dfile 1'
  'set x '_xstart' '_xend
  'set y '_ystart' '_yend
  'q dims'
  rec = sublin(result,5)
  currtime = subwrd(rec,6)

  if (_dispvar = "Forecast Track Only" | _dispvar = "35m Vector Wind" | _dispvar = "pmsl and 35m winds" | _dispvar = "Vertical Shear" | _dispvar = "Total Precip" | _dispvar = "Vector Wind" | _dispvar = "Relative Vorticity" | _dispvar = "10m Vector Wind")
    derived = "yes"
  else
    derived = "no"
  endif

  if (derived = "no")
    'set gxout stat'
    'd '_dispvar
    rec = sublin(result,8)
    min1 = subwrd(rec,4)
    max1 = subwrd(rec,5)
  endif

* --------------------------------------------------
* Plot the 1/12 degree data on right side of the
* screen, after setting dfile to appropriate 3-nest
* GRIB file.  If disptype = "static", then that means
* we are just doing a display, and not a step or a 
* loop (i.e., we display the current time's data but
* do NOT increment or decrement the time step).  If
* the user has selected the option to "clear b4 plotting",
* then the screen is refreshed before plotting; otherwise,
* the plots are just overlaid on each other.

  if (_disptype = "static")
    if (_dispopt = "clearplot")
      'clear graphics'
    endif
  else
*   if the disptype is "loop" then don't clear.  If the
*   disptype is "step", then that is the "step" option,
*   and we DO want to clear before each display....
    if (_disptype = "step")
      'clear graphics'
    endif
  endif

  ttemp = timeval + 1
  'set dfile 'ttemp
  'set x '_inxstart' '_inxend
  'set y '_inystart' '_inyend
  'set time 'currtime
  'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
  'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
  'set grads off'

  if (derived = "no")
    'set gxout stat'
    'd '_dispvar
    rec = sublin(result,8)
    min2 = subwrd(rec,4)
    max2 = subwrd(rec,5)
    
    if(min2 < min1); min = min2; else; min = min1; endif
    if(max2 > max1); max = max2; else; max = max1; endif
  endif
    
* save the current filename and time (this is for later use)

  'draw map'

  'q dims'

  rec = sublin(result,1) 
  _lasthrfn = subwrd(rec,5)
  trec = sublin(result,5)
  _lasthrti = subwrd(trec,6)
  
* Get x- and y-limits of the inner-nest plot so that we 
* have them for plotting the track on the inner-nest plot.
  
  'set gxout contour'
  'set black -9999999 9999999'
  'd pmsl'
  
  'q gxinfo'
  rec = sublin(result,1)
  _lastgraph = subwrd(rec,4)
  xrec = sublin(result,3)
  _gxinf161 = subwrd(xrec,4)
  _gxinf162 = subwrd(xrec,6)
  yrec = sublin(result,4)
  _gyinf161 = subwrd(yrec,4)
  _gyinf162 = subwrd(yrec,6)
  
* set the general plot options 

  if (_gxplottyp = "contour")
    'set gxout contour'
    'run setrbcols.gs'
    'set ccolor rainbow'
    'set clab on'
    'set cint '_defcint
  endif
  if (_gxplottyp = "shaded")
    'set gxout shaded'
    'run setrbcols.gs'
    'set ccolor rainbow'
    'set cint '_defcint
  endif
  if (_gxplottyp = "grid")
    'set gridln off'
    'set gxout grid'
    'set dignum '_grdsigdig
    'set digsiz '_grddigsiz
  endif

  if (_dispvar = "Forecast Track Only")
    'set gxout contour'
    'set black -9999999 9999999'
    'd pmsl'
    _trakopt = fulltrak
    if (_trakread = "notyet")
      rc = readtrak()
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "pmsl and 35m winds")
    'set gxout shaded'
    'run set_35m_levs.gs'
    'd mag(u35,v35)*1.9427'
    'run cbarn.gs 1.00 0 2.2 2.17'
    'set gxout contour'
    'set cint 4'
    'set clskip 2'
    'd pmsl/100'
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "Vertical Shear")
    'set gxout shaded'
    'run set_shr_levs.gs shaded '_windunit
    if (_windunit = "knots")
      'define udiff = u(lev='_shrlevhi')*1.9427 - u(lev='_shrlevlo')*1.9427'
      'define vdiff = v(lev='_shrlevhi')*1.9427 - v(lev='_shrlevlo')*1.9427'
    else
      'define udiff = u(lev='_shrlevhi') - u(lev='_shrlevlo')'
      'define vdiff = v(lev='_shrlevhi') - v(lev='_shrlevlo')'
    endif
    'display mag(udiff,vdiff)'
    'run cbarn.gs 1.00 0 2.2 2.17'
    'set gxout contour'
    'run set_shr_levs.gs contour '_windunit
    'set clab off'
    'display mag(udiff,vdiff)'

    'set gxout stat'
    'display mag(udiff,vdiff)'
    rec = sublin(result,8)
    maxvec = subwrd(rec,5)
*    say result
    imaxvec = int((maxvec+10)/10) * 10
*    say '1/6 degree imaxvec= 'imaxvec

    'set gxout vector'
    'set rbcols 1 1 1 1 1'
    'set ccolor rainbow'
    'set arrscl 0.4 'imaxvec
    'set arrlab off'
    skip = math_nint((_inxend-_inxstart)*_vecspcing/(_gxinf162-_gxinf161))
    'display skip(udiff,'skip','skip');vdiff'
    'set gxout contour'

    'q gxinfo'
    xrec = sublin(result,3)
    xl   = subwrd(xrec,4)
    xr   = subwrd(xrec,6)
    yrec = sublin(result,4)
    ylo  = subwrd(yrec,4)
    yhi  = subwrd(yrec,6)
    xsub = (xr - xl) / 8
    ysub = (yhi - ylo) / 15
    xl   = xr - xsub
    yhi  = ylo + ysub

    'set line 17 1 4'
    'draw polyf 'xr' 'ylo' 'xl' 'ylo' 'xl' 'yhi' 'xr' 'yhi' 'xr' 'ylo
    'set line 14 1 4'
    'draw rec 'xl' 'ylo' 'xr' 'yhi

    xstart = xl + 0.05
    ystart = (yhi - 0.1)
    xend   = xstart + 0.4
    'set line 43 1 6'
    'draw line 'xstart' 'ystart' 'xend' 'ystart
    'set strsiz 0.1 0.1'
    'set string 43 r 6 0'
    'draw string 'xend' 'ystart' >'
    ystart = ystart - 0.1
    'set strsiz 0.1 0.1'
    'set string 43 l 5 0'
    'draw string 'xstart' 'ystart' 'imaxvec
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "t")
    if (_tempunit = "degc")
      dispstr = "(t - 273.15)"
      min = min - 273.15
      max = max - 273.15
    else
      if (_tempunit = "degf")
        dispstr = "(((t - 273.15) * 9.0/5.0) + 32)"
        min = ((min - 273.15) * 9.0/5.0) + 32
        max = ((max - 273.15) * 9.0/5.0) + 32 
      else
        dispstr = "t"
      endif
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    min = (math_int(min/_defcint) - 1) * _defcint
    max = (math_int(max/_defcint) + 1) * _defcint
    'set rbrange 'min' 'max
    'display 'dispstr
    stndrdcbar = "yes"
    skipif = "yes"
  endif

  if (_dispvar = "sst")
    if (_tempunit = "degk")
      dispstr = "(sst + 273.15)"
    else
      if (_tempunit = "degf")
        dispstr = "((sst * 9.0/5.0) + 32)"
      else
        dispstr = "sst"
      endif
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
      'display 'dispstr
    else
      'set gxout shaded'
      'run set_temp_levs.gs shaded '_tempunit
      'display 'dispstr
      'run cbarn_temp.gs 1.22 0 2.3 2.17'
      'set gxout contour'
      'run set_temp_levs.gs contour '_tempunit
      'set clab off'
      'display 'dispstr
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "prcp")
    'define ptmp = prcp'
    rc = drawprcp(ptmp,nest3)
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "Total Precip")
    'set gxout contour'
    'set black -9999999 9999999'
    'd pmsl'
    cstr = "No totals shown for 1/12 degree plots...."
    'set strsiz 0.1 0.1'
    'set string 1 c 4 0'
    'draw string 2.5 5.0 'cstr
    'run set_prcp_levs.gs shaded '_prcpunit
    if (_prcpunit = "inches")
      'run cbtrick_prcpin.gs 1.20 0 2.3 2.17'
    endif
    if (_prcpunit = "cm")
      'run cbtrick_prcpcm.gs 1.20 0 2.3 2.17'
    endif
    if (_prcpunit = "mm")
      'run cbtrick_prcpmm.gs 1.20 0 2.3 2.17'
    endif
*   Call totprcp just so that we can get a title for
*   the plot for the subsequent call to plttitle
    rc = totprcp(timeval,nest3)
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "Vector Wind")
    if (_windunit = "knots")
      'define utmp = u * 1.9427'
      'define vtmp = v * 1.9427'
    else
      'define utmp = u'
      'define vtmp = v'
    endif
    if (_gxwindtyp = "stream")
      rc = pltstwnd(utmp,vtmp,nest3)
    else
      rc = pltvcwnd(utmp,vtmp,nest3)
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "35m Vector Wind")
    if (_windunit = "knots")
      'define utmp = u35 * 1.9427'
      'define vtmp = v35 * 1.9427'
    else
      'define utmp = u35'
      'define vtmp = v35'
    endif
    if (_gxwindtyp = "stream")
      rc = pltstwnd(utmp,vtmp,nest3)
    else
      rc = pltvcwnd(utmp,vtmp,nest3)
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "10m Vector Wind")
    if (_windunit = "knots")
      'define utmp = u10 * 1.9427'
      'define vtmp = v10 * 1.9427'
    else
      'define utmp = u10'
      'define vtmp = v10'
    endif
    if (_gxwindtyp = "stream")
      rc = pltstwnd(utmp,vtmp,nest3)
    else
      rc = pltvcwnd(utmp,vtmp,nest3)
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif
  
  if (_dispvar = "rh")
    
    if (_rhbug = 1)
      dispstr = "(rh*100)"
    else
      dispstr = "rh"
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    if (_gxplottyp = "shaded")
      'run set_rh_scheme.gs shaded xxx'
    else
      min = (math_int(min/_defcint) - 1) * _defcint
      max = (math_int(max/_defcint) + 1) * _defcint
     'set rbrange 'min' 'max
    endif
    'display 'dispstr
    if (_gxplottyp = "shaded")
      'run cbarn_small.gs 1.20 0 2.3 2.17'
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif
  
  if (_dispvar = "omega")
    dispstr = "omega"
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    if (_gxplottyp = "shaded")
      'run set_omega_scheme.gs shaded xxx'
    else
      min = (math_int(min/_defcint) - 1) * _defcint
      max = (math_int(max/_defcint) + 1) * _defcint
     'set rbrange 'min' 'max
    endif
    'display 'dispstr
    if (_gxplottyp = "shaded")
      'run cbarn_small.gs 1.20 0 2.3 2.17'
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "icmix")
    if (_dispvar = "icmix")
      dispstr = "icmix"
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    if (_gxplottyp = "shaded")
      'run set_icmix_scheme.gs shaded xxx'
    else
      min = (math_int(min/_defcint) - 1) * _defcint
      max = (math_int(max/_defcint) + 1) * _defcint
     'set rbrange 'min' 'max
    endif
    'display 'dispstr
    if (_gxplottyp = "shaded")
      'run cbarn_small.gs 1.20 0 2.3 2.17'
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "totcwat" | _dispvar = "totrain" | _dispvar = "totsnow" | _dispvar = "totcond")
    if (_dispvar = "totcwat")
      dispstr = "totcwat"
    endif
    if (_dispvar = "totrain")
      dispstr = "totrain"
    endif
    if (_dispvar = "totsnow")
      dispstr = "totsnow"
    endif
    if (_dispvar = "totcond")
      dispstr = "totcond"
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    if (_gxplottyp = "shaded")
      'run set_totvar_scheme.gs shaded xxx'
    else
      min = (math_int(min/_defcint) - 1) * _defcint
      max = (math_int(max/_defcint) + 1) * _defcint
     'set rbrange 'min' 'max
    endif
    'display 'dispstr
    if (_gxplottyp = "shaded")
      'run cbarn_small.gs 1.20 0 2.3 2.17'
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (_dispvar = "ch" | _dispvar = "cd" | _dispvar = "chcd" | _dispvar = "znot" | _dispvar = "ztherm")
    if (_dispvar = "ch")
      'run set_ch_levs.gs '_gxplottyp
      dispstr = "ch"
    endif
    if (_dispvar = "cd")
      'run set_cd_levs.gs '_gxplottyp
      dispstr = "cd"
    endif
    if (_dispvar = "chcd")
      'run set_chcd_levs.gs '_gxplottyp
      dispstr = "chcd"
    endif
    if (_dispvar = "znot")
      'run set_znot_levs.gs '_gxplottyp
      dispstr = "znot"
    endif
    if (_dispvar = "ztherm")
      'run set_ztherm_levs.gs '_gxplottyp
      dispstr = "ztherm"
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif

*    if (_gxplottyp = "shaded")
*      'run set_totvar_levs.gs shaded xxx'
*    else
*      min = (math_int(min/_defcint) - 1) * _defcint
*      max = (math_int(max/_defcint) + 1) * _defcint
*     'set rbrange 'min' 'max
*    endif

    'display 'dispstr
    if (_gxplottyp = "shaded")
      'run cbarn_small.gs 1.20 0 2.3 2.17'
    endif
    stndrdcbar = "no"
    skipif = "yes"
  endif

  if (skipif != "yes")
    if (_dispvar = "pmsl")
      dispstr = "("%_dispvar%"/100.0)"
      min = min/100.0
      max = max/100.0
      min = (math_int(min/_defcint) - 1) * _defcint
      max = (math_int(max/_defcint) + 1) * _defcint
      'set rbrange 'min' 'max
      stndrdcbar = "yes"
    else; if (_dispvar = "Relative Vorticity")
      'set cint 1'
      dispstr = "(hcurl(u,v)*1e5)"
      stndrdcbar = "no"
    else; if (_dispvar = "ps")
      dispstr = "("%_dispvar%"/100.0)"
      min = min/100.0
      max = max/100.0
      min = (math_int(min/_defcint) - 1) * _defcint
      max = (math_int(max/_defcint) + 1) * _defcint
      'set rbrange 'min' 'max
      stndrdcbar = "yes"
   else
      min = (math_int(min/_defcint) - 1) * _defcint
      max = (math_int(max/_defcint) + 1) * _defcint
      'set rbrange 'min' 'max
      dispstr = _dispvar
      stndrdcbar = "yes"
    endif; endif; endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    'display 'dispstr
  endif

  if (derived = "no" & stndrdcbar = "yes" & _gxplottyp = "shaded")
    if((max2 - min2) >= (max1 - min1))
      'q shades'
      fname = "/net/"%_userid%"/temp/cbtrick_small.dat"
      rc = write(fname, result)
      rc = close(fname)
    endif
  endif

  rc = plttitle(timeval)
  rc = plotgfdl()
  
  'set dfile 1'

* ----------------------------------------------------
* Now plot the coarse data on left side of screen.

  'set dfile 1'
  'set x '_xstart' '_xend
  'set y '_ystart' '_yend
  'set time 'currtime

  'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
  'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
  'set grads off'
    
* Get x- and y-limits of this 1-degree plot so that in case
* the user selects to change the lat and lon boundaries,
* we'll know where the valid boundaries are for clicking
* in that window....

  'set gxout contour'
  'set black -9999999 9999999'
  'd pmsl'

  'q gxinfo'
  rec = sublin(result,1)
  _lastgraph = subwrd(rec,4)
  xrec = sublin(result,3)
  _gxinfox1 = subwrd(xrec,4)
  _gxinfox2 = subwrd(xrec,6)
  yrec = sublin(result,4)
  _gxinfoy1 = subwrd(yrec,4)
  _gxinfoy2 = subwrd(yrec,6)
  
* set the general plot options 

  if (_gxplottyp = "contour")
    'set gxout contour'
    'run setrbcols.gs'
    'set ccolor rainbow'
    'set clab on'
    'set cint '_defcint
  endif
  if (_gxplottyp = "shaded")
    'set gxout shaded'
    'run setrbcols.gs'
    'set ccolor rainbow'
    'set cint '_defcint
  endif
  if (_gxplottyp = "grid")
    'set gridln off'
    'set gxout grid'
    'set dignum '_grdsigdig
    'set digsiz '_grddigsiz
  endif

  if (_dispvar = "Forecast Track Only")
    'set black -9999999 9999999'
    'd pmsl'
    _trakopt = fulltrak
    if (_trakread = "notyet")
      rc = readtrak()
    endif
    skipif = "yes"
  endif

  if (_dispvar = "pmsl and 35m winds")
    'set gxout shaded'
    'run set_35m_levs.gs'
    'd mag(u35,v35)*1.9427'
    'set gxout contour'
    'set cint 4'
    'set clskip 2'
    'd pmsl/100'
    skipif = "yes"
  endif

  if (_dispvar = "Vertical Shear")
    'set gxout shaded'
    'run set_shr_levs.gs shaded '_windunit
    if (_windunit = "knots")
      'define udiff = u(lev='_shrlevhi')*1.9427 - u(lev='_shrlevlo')*1.9427'
      'define vdiff = v(lev='_shrlevhi')*1.9427 - v(lev='_shrlevlo')*1.9427'
    else
      'define udiff = u(lev='_shrlevhi') - u(lev='_shrlevlo')'
      'define vdiff = v(lev='_shrlevhi') - v(lev='_shrlevlo')'
    endif
    'display mag(udiff,vdiff)'
    'set gxout contour'
    'run set_shr_levs.gs contour '_windunit
    'set clab off'
    'display mag(udiff,vdiff)'

    'set gxout stat'
    'display mag(udiff,vdiff)'
    rec = sublin(result,8)
    maxvec = subwrd(rec,5)
    imaxvec = int((maxvec+10)/10) * 10

    'set gxout vector'
    'set rbcols 1 1 1 1 1'
    'set ccolor rainbow'
    'set arrscl 0.4 'imaxvec
    'set arrlab off'
    skip = math_nint((_xend-_xstart)*_vecspcing/(_gxinfox2-_gxinfox1))
    'display skip(udiff,'skip','skip');vdiff'
    'set gxout contour'

    'q gxinfo'
    xrec = sublin(result,3)
    xl   = subwrd(xrec,4)
    xr   = subwrd(xrec,6)
    yrec = sublin(result,4)
    ylo  = subwrd(yrec,4)
    yhi  = subwrd(yrec,6)
    xsub = (xr - xl) / 8
    ysub = (yhi - ylo) / 15
    xcheck = (xsub/ysub)
    if (xcheck > 2)
      xsub = ysub
    endif
    if (xsub < 0.4)
      xsub = 0.5
      ysub = 0.5
    endif

    xl   = xr - xsub
    yhi  = ylo + ysub

*    say 'xsub= 'xsub'  ysub= 'ysub

    'set line 17 1 4'
    'draw polyf 'xr' 'ylo' 'xl' 'ylo' 'xl' 'yhi' 'xr' 'yhi' 'xr' 'ylo
    'set line 14 1 4'
    'draw rec 'xl' 'ylo' 'xr' 'yhi

    xstart = xl + 0.05
    ystart = (yhi - 0.1)
    xend   = xstart + 0.4
    'set line 43 1 6'
    'draw line 'xstart' 'ystart' 'xend' 'ystart
    'set strsiz 0.1 0.1'
    'set string 43 r 6 0'
    'draw string 'xend' 'ystart' >'
    ystart = ystart - 0.15
    'set strsiz 0.1 0.1'
    'set string 43 l 4 0'
    'draw string 'xstart' 'ystart' 'imaxvec

    skipif = "yes"
  endif

  if (_dispvar = "t")
    if (_tempunit = "degc")
      dispstr = "(t - 273.15)"
    else
      if (_tempunit = "degf")
        dispstr = "(((t - 273.15) * 9.0/5.0) + 32)"
      else
        dispstr = "t"
      endif
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_xend-_xstart)*_grdspcing/(_gxinfox2-_gxinfox1))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    'set rbrange 'min' 'max
    'display 'dispstr
    skipif = "yes"
  endif

  if (_dispvar = "sst")
    if (_tempunit = "degk")
*      dispstr = "(sst + 273.15)"
      dispstr = "sst"
    else
      if (_tempunit = "degf")
*        dispstr = "((sst * 9/5) + 32)"
        dispstr = "(((sst-273.15) * 9.0/5.0) + 32)"
      else
*        dispstr = "sst"
        dispstr = "(sst -273.15)"
      endif
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_xend-_xstart)*_grdspcing/(_gxinfox2-_gxinfox1))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
      'display 'dispstr
    else
      'set gxout shaded'
      'run set_temp_levs.gs shaded '_tempunit
      'display 'dispstr
*      'set gxout contour'
*      'run set_temp_levs.gs contour '_tempunit
*      'set clab off'
*      'display 'dispstr
    endif
    skipif = "yes"
  endif

  if (_dispvar = "prcp")
    'define ptmp = prcp'
    rc = drawprcp(ptmp,1deg)
    skipif = "yes"
  endif

  if (_dispvar = "Total Precip")
*    say 'calling totprcp for 1-degree, timeval= 'timeval
    rc = totprcp(timeval,1deg)
    skipif = "yes"
  endif

  if (_dispvar = "Vector Wind")
    if (_windunit = "knots")
      'define utmp = u * 1.9427'
      'define vtmp = v * 1.9427'
    else
      'define utmp = u'
      'define vtmp = v'
    endif
    if (_gxwindtyp = "stream")
      rc = pltstwnd(utmp,vtmp,1deg)
    else
      rc = pltvcwnd(utmp,vtmp,1deg)
    endif
    skipif = "yes"
  endif

  if (_dispvar = "35m Vector Wind")
    if (_windunit = "knots")
      'define utmp = u35 * 1.9427'
      'define vtmp = v35 * 1.9427'
    else
      'define utmp = u35'
      'define vtmp = v35'
    endif
    if (_gxwindtyp = "stream")
      rc = pltstwnd(utmp,vtmp,1deg)
    else
      rc = pltvcwnd(utmp,vtmp,1deg)
    endif
    skipif = "yes"
  endif

  if (_dispvar = "10m Vector Wind")
    if (_windunit = "knots")
      'define utmp = u10 * 1.9427'
      'define vtmp = v10 * 1.9427'
    else
      'define utmp = u10'
      'define vtmp = v10'
    endif
    if (_gxwindtyp = "stream")
      rc = pltstwnd(utmp,vtmp,1deg)
    else
      rc = pltvcwnd(utmp,vtmp,1deg)
    endif
    skipif = "yes"
  endif
  
  if (_dispvar = "rh")
    if (_gxplottyp = "shaded")
      'run set_rh_scheme.gs shaded xxx'
    else
      'set rbrange 'min' 'max
    endif
    dispstr = "rh"
    if (_gxplottyp = "grid")
      skip = math_nint((_xend-_xstart)*_grdspcing/(_gxinfox2-_gxinfox1))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    'display 'dispstr
    skipif = "yes"
  endif
  
  if (_dispvar = "omega")
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    if (_gxplottyp = "shaded")
      'run set_omega_scheme.gs shaded xxx'
    else
      'set rbrange 'min' 'max
    endif
    'display 'dispstr
    skipif = "yes"
  endif

  if (_dispvar = "icmix")
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    if (_gxplottyp = "shaded")
      'run set_icmix_scheme.gs shaded xxx'
    else
      'set rbrange 'min' 'max
    endif
    'display 'dispstr
    skipif = "yes"
  endif

  if (_dispvar = "totcwat" | _dispvar = "totrain" | _dispvar = "totsnow" | _dispvar = "totcond")
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    if (_gxplottyp = "shaded")
      'run set_totvar_scheme.gs shaded xxx'
    else
      'set rbrange 'min' 'max
    endif
    'display 'dispstr
    skipif = "yes"
  endif

  if (_dispvar = "ch" | _dispvar = "cd" | _dispvar = "chcd" | _dispvar = "znot" | _dispvar = "ztherm")
    if (_dispvar = "ch")
      'run set_ch_levs.gs '_gxplottyp
    endif
    if (_dispvar = "cd")
      'run set_cd_levs.gs '_gxplottyp
    endif
    if (_dispvar = "chcd")
      'run set_chcd_levs.gs '_gxplottyp
    endif
    if (_dispvar = "znot")
      'run set_znot_levs.gs '_gxplottyp
    endif
    if (_dispvar = "ztherm")
      'run set_ztherm_levs.gs '_gxplottyp
    endif
    if (_gxplottyp = "grid")
      skip = math_nint((_inxend-_inxstart)*_grdspcing/(_gxinf162-_gxinf161))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif

*    if (_gxplottyp = "shaded")
*      'run set_totvar_levs.gs shaded xxx'
*    else
*      min = (math_int(min/_defcint) - 1) * _defcint
*      max = (math_int(max/_defcint) + 1) * _defcint
*     'set rbrange 'min' 'max
*    endif

    'display 'dispstr
    skipif = "yes"
  endif

  if (skipif != "yes")
    'run setrbcols.gs'
    'set ccolor rainbow'
    if (_dispvar = "pmsl")
      dispstr = "("%_dispvar%"/100)"
      'set rbrange 'min' 'max
    else; if (_dispvar = "Relative Vorticity")
      'set cint 1'
      dispstr = "(hcurl(u,v)*1e5)"
    else; if (_dispvar = "ps")
      dispstr = "("_dispvar%"/100)"
      'set rbrange 'min' 'max
    else
      'set rbrange 'min' 'max
      dispstr = _dispvar
    endif; endif; endif
    if (_gxplottyp = "grid")
      skip = math_nint((_xend-_xstart)*_grdspcing/(_gxinfox2-_gxinfox1))
      dispstr = "skip("%dispstr%","%skip%","%skip%")"
    endif
    'display 'dispstr
  endif
      
  if (derived = "no" & stndrdcbar = "yes" & _gxplottyp = "shaded")
    if((max2 - min2) < (max1 - min1))
      'q shades'
      fname = "/net/"%_userid%"/temp/cbtrick_small.dat"
      rc = write(fname, result)
      rc = close(fname)
    endif
    
    'set dfile '_lasthrfn
    'set x '_inxstart' '_inxend
    'set y '_inystart' '_inyend
    'set gxout contour'
    'set time '_lasthrti
    'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
    'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
    'set black -99999999 99999999'
    'set grads off'
    'd pmsl'
    
    'run cbtrick_small.gs 1.20 0 2.3 2.17 'fname
        
    'set dfile 1'
    'set x '_xstart' '_xend
    'set y '_ystart' '_yend
    'set time 'currtime
    
  endif

  rc = redomenu()

return

*----------------------------*
*
*----------------------------*
function pltvcwnd(utmp,vtmp,gridtype)

* This function plots the vector wind.  Much of the extra stuff 
* that makes up all the stuff in this function is to control the
* length of the vector arrows and to place them in a box at the
* lower right hand corner of the plots.  

  if (gridtype = "nest3")

    'set gxout shaded'
    'run set_wnd_levs.gs shaded '_windunit
    'display mag(utmp,vtmp)'
   
*   Use the cbarn_small.gs version since it has been 
*   modified to use the smaller font....

    'run cbarn_small.gs 1.20 0 2.3 2.17'
*    'run cbarn.gs 1.00 0 2.2 2.13'
    'set gxout contour'
    'run set_wnd_levs.gs contour '_windunit
    'set clab off'
    'display mag(utmp,vtmp)'

*   Find out what the max vector is, and round it
*   up to the next 10.

    'set gxout stat'
    'display mag(utmp,vtmp)'
    rec = sublin(result,8)
    maxvec = subwrd(rec,5)
*    say result
    imaxvec = int((maxvec+10)/10) * 10
*    say '1/6 degree imaxvec= 'imaxvec

*   Now that we know what the max vector is, plot the
*   vectors, and force the max vector to be of the size
*   indicated in the "set arrscl" statement.

    'set gxout vector'
*    'set rgb 26 160  60  95'
    'set rgb 87 255   0 255'
    'set ccolor 87'
    'set arrscl 0.4 'imaxvec
    'set arrlab off'
    skip = math_nint((_inxend-_inxstart)*_vecspcing/(_gxinf162-_gxinf161))
    'display skip(utmp,'skip','skip');vtmp'
    'set gxout contour'

*   Now create a box at the lower right hand corner of the
*   screen to put an arrow showing the length of the max
*   vector.  Yes, GrADS can do this automatically, but if 
*   you let it do it automatically here, it will put that
*   max vector directly over the color bar.

    'q gxinfo'
    xrec = sublin(result,3)
    xl   = subwrd(xrec,4)
    xr   = subwrd(xrec,6)
    yrec = sublin(result,4)
    ylo  = subwrd(yrec,4)
    yhi  = subwrd(yrec,6)
    xsub = (xr - xl) / 8
    ysub = (yhi - ylo) / 15
    xl   = xr - xsub
    yhi  = ylo + ysub

*   Create a box in the lower right hand corner....

    'set line 17 1 4'
    'draw polyf 'xr' 'ylo' 'xl' 'ylo' 'xl' 'yhi' 'xr' 'yhi' 'xr' 'ylo
    'set line 14 1 4'
    'draw rec 'xl' 'ylo' 'xr' 'yhi

*   Now create the arrow that goes in that box.  The length
*   of the arrow is determined by the "xend = " statement, and
*   the amount that you add to the xstart in that statement
*   must be the same as the size you specify in your arrscl 
*   statement.  The call to set_shr_levs.gs is so that the 
*   color 43 can be defined.

    'run set_shr_levs.gs shaded '_windunit

    xstart = xl + 0.05
    ystart = (yhi - 0.1)
    xend   = xstart + 0.4
    'set line 43 1 6'
    'draw line 'xstart' 'ystart' 'xend' 'ystart
    'set strsiz 0.1 0.1'
    'set string 43 r 6 0'
    'draw string 'xend' 'ystart' >'
    ystart = ystart - 0.1
    'set strsiz 0.1 0.1'
    'set string 43 l 5 0'
    'draw string 'xstart' 'ystart' 'imaxvec

  else

    'set gxout shaded'
    'run set_wnd_levs.gs shaded '_windunit
    'display mag(utmp,vtmp)'
    'set gxout contour'
    'run set_wnd_levs.gs contour '_windunit
    'set clab off'
    'display mag(utmp,vtmp)'

*   Find out what the max vector is, and round it
*   up to the next 10.

    'set gxout stat'
    'display mag(utmp,vtmp)'
    rec = sublin(result,8)
    maxvec = subwrd(rec,5)
*    say result
    imaxvec = int((maxvec+10)/10) * 10
*    say '1 degree imaxvec= 'imaxvec

*   Now that we know what the max vector is, plot the
*   vectors, and force the max vector to be of the size
*   indicated in the "set arrscl" statement.

    'set gxout vector'
*    'set rgb 26 160  60  95'
*    'set rgb 27 255   0 150'
    'set rgb 87 255   0 255'
    'set ccolor 87'
    'set arrscl 0.5 'imaxvec
    'set arrlab off'
    skip = math_nint((_xend-_xstart)*_vecspcing/(_gxinfox2-_gxinfox1))
    'display skip(utmp,'skip','skip');vtmp'
    'set gxout contour'

*   Now create a box at the lower right hand corner of the
*   screen to put an arrow showing the length of the max
*   vector.  Yes, GrADS can do this automatically, but if
*   you let it do it automatically here, it will put that
*   max vector directly over the color bar for the track 
*   intensity, should the user have chosen to plot that.
*   Note that there is some fudging that goes on, in case 
*   the user has modified the lat/lon bounds and created a
*   map size that is exceptionally narrow.  In that case,
*   we force the box to be square, as opposed to being as
*   narrow as the bigger map box is.

    'q gxinfo'
*    say 'gxinfo for 1 degree....'
*    say result
    xrec = sublin(result,3)
    xl   = subwrd(xrec,4)
    xr   = subwrd(xrec,6)
    yrec = sublin(result,4)
    ylo  = subwrd(yrec,4)
    yhi  = subwrd(yrec,6)
    xsub = (xr - xl) / 8
    ysub = (yhi - ylo) / 15
    xcheck = (xsub/ysub)
    if (xcheck > 2)
      xsub = ysub
    endif
    if (xsub < 0.4)
      xsub = 0.5
      ysub = 0.5
    endif

    xl   = xr - xsub
    yhi  = ylo + ysub

*    say 'xsub= 'xsub'  ysub= 'ysub

    'set line 17 1 4'
    'draw polyf 'xr' 'ylo' 'xl' 'ylo' 'xl' 'yhi' 'xr' 'yhi' 'xr' 'ylo
    'set line 14 1 4'
    'draw rec 'xl' 'ylo' 'xr' 'yhi

*   Now create the arrow that goes in that box.  The length
*   of the arrow is determined by the "xend = " statement, and
*   the amount that you add to the xstart in that statement
*   must be the same as the size you specify in your arrscl
*   statement.  The call to set_shr_levs.gs is so that the 
*   color 43 can be defined.

    'run set_shr_levs.gs shaded '_windunit

    xstart = xl + 0.05
    ystart = (yhi - 0.1)
    xend   = xstart + 0.5
    'set line 43 1 6'
    'draw line 'xstart' 'ystart' 'xend' 'ystart
    'set strsiz 0.1 0.1'
    'set string 43 r 6 0'
    'draw string 'xend' 'ystart' >'
    ystart = ystart - 0.15
    'set strsiz 0.13 0.13'
    'set string 43 l 4 0'
    'draw string 'xstart' 'ystart' 'imaxvec

  endif

return

*----------------------------*
*
*----------------------------*
function pltstwnd(utmp,vtmp,gridtype)

* This function plots streamlines of the wind.

  if (gridtype = "nest3")

    'set gxout shaded'
    'run set_wnd_levs.gs shaded '_windunit
    'display mag(utmp,vtmp)'
   
*   Use the cbarn_small.gs version since it has been 
*   modified to use the smaller font....

    'run cbarn_small.gs 1.20 0 2.3 2.17'
*    'run cbarn.gs 1.00 0 2.2 2.13'
    'set gxout contour'
    'run set_wnd_levs.gs contour '_windunit
    'set clab off'
    'display mag(utmp,vtmp)'

*   Find out what the max vector is, and round it
*   up to the next 10.

    'set gxout stat'
    'display mag(utmp,vtmp)'
    rec = sublin(result,8)
    maxvec = subwrd(rec,5)
*    say result
    imaxvec = int((maxvec+10)/10) * 10
*    say '1/6 degree imaxvec= 'imaxvec

*   Now that we know what the max vector is, plot the
*   vectors, and force the max vector to be of the size
*   indicated in the "set arrscl" statement.

    'set gxout stream'
*    'set rgb 26 160  60  95'
    'set rgb 87 255   0 255'
    'set ccolor 87'
**    'set arrscl 0.4 'imaxvec
**    'set arrlab off'
**    skip = math_nint((_inxend-_inxstart)*_vecspcing/(_gxinf162-_gxinf161))
**    'display skip(utmp,'skip','skip');vtmp'
    'set strmden '_innerdens
    'display utmp;vtmp'
    'set gxout contour'

  else

    'set gxout shaded'
    'run set_wnd_levs.gs shaded '_windunit
    'display mag(utmp,vtmp)'
    'set gxout contour'
    'run set_wnd_levs.gs contour '_windunit
    'set clab off'
    'display mag(utmp,vtmp)'

*   Find out what the max vector is, and round it
*   up to the next 10.

    'set gxout stat'
    'display mag(utmp,vtmp)'
    rec = sublin(result,8)
    maxvec = subwrd(rec,5)
*    say result
    imaxvec = int((maxvec+10)/10) * 10
*    say '1 degree imaxvec= 'imaxvec

*   Now that we know what the max vector is, plot the
*   vectors, and force the max vector to be of the size
*   indicated in the "set arrscl" statement.

    'set gxout stream'
*    'set rgb 26 160  60  95'
*    'set rgb 27 255   0 150'
    'set rgb 87 255   0 255'
    'set ccolor 87'
**    'set arrscl 0.5 'imaxvec
**    'set arrlab off'
**    skip = math_nint((_xend-_xstart)*_vecspcing/(_gxinfox2-_gxinfox1))
**    'display skip(utmp,'skip','skip');vtmp'
    'set cthick 1'
    'set strmden '_outerdens
**    'define uskip = skip(utmp,3,3)'
**    'define vskip = skip(vtmp,3,3)'
**    'display skip(utmp,3,3);vtmp'
    'display utmp;vtmp'
    'set gxout contour'

  endif

return
*----------------------------*
*
*----------------------------*
function totprcp(timeval,gridtype)

  if (_timemax = 22)
    _fcsttype = "5day"
    maxprcptime = 6
  else
    _fcsttype = "3day"
    maxprcptime = 4
  endif

  if (timeval > maxprcptime)
    if (gridtype = "1deg")
      say ' '
      say ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
      say ' !!!                                         !!! '
      say ' !!!  NOTE: FOR PLOTTING THE PRECIP TOTALS,  !!! '
      say ' !!!        YOUR SELECTED CURRENT TIME IS    !!! '
      say ' !!!        PAST THE LIMIT FOR YOUR TYPE OF  !!! '
      say ' !!!        FORECAST (3-DAY/5-DAY).  WE WILL !!! '
      say ' !!!        PLOT THE LAST TOTALS PLOT (THE   !!! '
      say ' !!!        ONE CONTAINING THE 3-DAY OR      !!! '
      say ' !!!        5-DAY TOTAL), BUT FOR EARLIER    !!! '
      say ' !!!        1-DAY TOTALS, YOU MUST CHANGE    !!! '
      say ' !!!        THE TIME DIMENSION IN THE MENU   !!! '
      say ' !!!        AT THE TOP *OR* HIT THE "t=0"    !!! '
      say ' !!!        IN THE LOWER RIGHT CORNER.       !!! '
      say ' !!!                                         !!! '
      say ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
      say ' '
    endif
    prcptime = maxprcptime
  else
    prcptime = timeval
  endif

*  say 'In totprcp, prcptime= 'prcptime'  timeval= 'timeval
*  say 'In totprcp, maxprcptime= 'maxprcptime

  if (prcptime < maxprcptime)

    if (prcptime = 1)
      if (gridtype = "1deg")
        'define ptmp = mean(prcp,t=2,t=5) * 4'
        rc = drawprcp(ptmp,1deg)
      endif
      _totptitl = 'Day 1 (0-24h) Total Precip ('%_prcpunit%')'
*      say 'In totprcp 1, _totptitl= '_totptitl
    endif
    if (prcptime = 2)
      if (gridtype = "1deg")
        'define ptmp = mean(prcp,t=6,t=9) * 4'
        rc = drawprcp(ptmp,1deg)
      endif
      _totptitl = 'Day 2 (24-48h) Total Precip ('%_prcpunit%')'
*      say 'In totprcp 2, _totptitl= '_totptitl
    endif
    if (prcptime = 3)
      if (gridtype = "1deg")
        'define ptmp = mean(prcp,t=10,t=13) * 4'
        rc = drawprcp(ptmp,1deg)
      endif
      _totptitl = 'Day 3 (48-72h) Total Precip ('%_prcpunit%')'
*      say 'In totprcp 3, _totptitl= '_totptitl
    endif
    if (prcptime = 4)
      if (gridtype = "1deg")
        'define ptmp = mean(prcp,t=14,t=17) * 4'
        rc = drawprcp(ptmp,1deg)
      endif
      _totptitl = 'Day 4 (72-96h) Total Precip ('%_prcpunit%')'
*      say 'In totprcp 4, _totptitl= '_totptitl
    endif
    if (prcptime = 5)
      if (gridtype = "1deg")
        'define ptmp = mean(prcp,t=18,t=21) * 4'
        rc = drawprcp(ptmp,1deg)
      endif
      _totptitl = 'Day 5 (96-120h) Total Precip ('%_prcpunit%')'
*      say 'In totprcp 5, _totptitl= '_totptitl
    endif

  else

    if (_fcsttype = "3day")
      if (gridtype = "1deg")
        'define ptmp = mean(prcp,t=2,t=14)*13'
        rc = drawprcp(ptmp,1deg)
      endif
      _totptitl = '3-day (0-78h) Total Precip ('%_prcpunit%')'
*      say 'In totprcp 3day, _totptitl= '_totptitl
    else
      if (gridtype = "1deg")
        'define ptmp = mean(prcp,t=2,t=22)*21'
        rc = drawprcp(ptmp,1deg)
      endif
      _totptitl = '5-day (0-126h) Total Precip ('%_prcpunit%')'
*      say 'In totprcp 5day, _totptitl= '_totptitl
    endif

  endif

return

*---------------------*
*
*---------------------*
function drawprcp(ptmp,gridtype)

*  say 'in drawprcp, prcpunit = '_prcpunit

  'set gxout shaded'
  'run set_prcp_levs.gs shaded '_prcpunit
  if (_prcpunit = "inches")
    'display ptmp / 10 * 0.3937'
  endif
  if (_prcpunit = "cm")
    'display ptmp / 10'
  endif
  if (_prcpunit = "mm")
    'display ptmp'
  endif

  if (gridtype = "nest3")
    'run cbarn_small.gs 1.20 0 2.3 2.17'
  endif

  'set gxout contour'
  'run set_prcp_levs.gs contour '_prcpunit
  'set clab off'
  if (_prcpunit = "inches")
    'display ptmp / 10 * 0.3937'
  endif
  if (_prcpunit = "cm")
    'display ptmp / 10'
  endif
  if (_prcpunit = "mm")
    'display ptmp'
  endif
  'set clab on'

return

*---------------------*
*
*---------------------*
function initmenu()

  'draw dropmenu 1 0.75 8.35 1.00 0.25 Main | '_filestuff
  'draw dropmenu 2 2.00 8.35 1.10 0.25 Storms |'_stormlist
  'draw dropmenu 3 3.20 8.35 0.90 0.25 Vars | No files open yet'
  'draw dropmenu 4 4.25 8.35 0.90 0.25 Levs | No files open yet'
  'draw dropmenu 5 5.15 8.35 0.50 0.25 t | No files open yet'
  'draw dropmenu 6 5.90 8.35 0.75 0.25 Opts | '_optstuff
  'draw dropmenu 7 6.90 8.35 1.05 0.25 Opts_2 | '_opt2stuff
  'draw dropmenu 8 8.07 8.35 1.05 0.25 Opts_3 | '_opt3stuff
  'draw dropmenu 9 9.60 8.35 1.60 0.25 Vertical_Profile | No Files'

  'draw dropmenu 10 cascade '_odensstr
  'draw dropmenu 11 cascade '_idensstr
  
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 16 7.10 1.53 1.00 0.40 <step'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 17 8.25 1.53 1.00 0.40 step>'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 18 7.10 1.00 1.00 0.40 <<loop'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 19 8.25 1.00 1.00 0.40 loop>>'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 31 9.52 1.00 1.25 0.40 <display>'
  'set button  5 0 4 5 7 0 5 4 6'
  'draw button 20 9.30 1.53 0.75 0.40 t=0'

* Now draw the buttons for the setting of the 
* loop speed....

  'set button  6 0 15 15 6 0 15 15 6'
  'draw button 21 7.03 0.45 0.90 0.40 speed'
  'set button  6 0 15 15 6 0 15 15 6'
  'draw button 22 7.70 0.45 0.30 0.40  -'
  'set button  6 0 15 15 6 0 15 15 6'
  'draw button 23 9.65 0.45 0.30 0.40  +'

  ict  = 1
  xpos = 8.05
  while (ict < 6)
    colnum  = _spdcol.ict
    if (ict = 3) 
      fgcol = 6
      bgcol = 6
    else
      fgcol = 15
      bgcol = 0
    endif
    bnum    = 23 + ict
    'set button 'fgcol' 'bgcol' 15 15 'fgcol' 'bgcol' 15 15 6'
    'draw button 'bnum' 'xpos' 0.45 0.30 0.30 .'
    ict = ict + 1
    xpos = xpos + 0.3
  endwhile

   _spdcol.1 = 15
   _spdcol.2 = 15
   _spdcol.3 = 6
   _spdcol.4 = 15
   _spdcol.5 = 15

return

*---------------------*
*
*---------------------*
function redomenu()

  'clear dropmenu 1'
  'clear dropmenu 2'
  'clear dropmenu 3'
  'clear dropmenu 4'
  'clear dropmenu 5'
  'clear dropmenu 6'
  'clear dropmenu 7'
  'clear dropmenu 8'
  'clear dropmenu 9'
  'clear button 16'
  'clear button 17'
  'clear button 18'
  'clear button 19'
  'clear button 20'
  'clear button 31'
  'clear button 21'
  'clear button 22'
  'clear button 23'
  'clear button 24'
  'clear button 25'
  'clear button 26'
  'clear button 27'
  'clear button 28'

  'draw dropmenu 1 0.75 8.35 1.00 0.25 Main | '_filestuff
  'draw dropmenu 2 2.00 8.35 1.10 0.25 Storms |'_stormlist
  'draw dropmenu 3 3.20 8.35 0.90 0.25 Vars |'_varlist
  'draw dropmenu 4 4.25 8.35 0.90 0.25 Levs |'_levlist
  'draw dropmenu 5 5.15 8.35 0.50 0.25 t |'_fhrlist
  'draw dropmenu 6 5.90 8.35 0.75 0.25 Opts | '_optstuff
  'draw dropmenu 7 6.90 8.35 1.05 0.25 Opts_2 | '_opt2stuff
  'draw dropmenu 8 8.07 8.35 1.05 0.25 Opts_3 | '_opt3stuff
  'draw dropmenu 9 9.60 8.35 1.60 0.25 Vertical_Profile | '_vpflstuff

  'draw dropmenu 10 cascade '_odensstr
  'draw dropmenu 11 cascade '_idensstr

  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 16 7.10 1.53 1.00 0.40 <step'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 17 8.25 1.53 1.00 0.40 step>'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 18 7.10 1.00 1.00 0.40 <<loop'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 19 8.25 1.00 1.00 0.40 loop>>'
  'set button  3 0 4 5 7 0 5 4 6'
  'draw button 31 9.52 1.00 1.25 0.40 <display>'
  'set button  5 0 4 5 7 0 5 4 6'
  'draw button 20 9.30 1.53 0.75 0.40 t=0'

  'set button  6 0 15 15 6 0 15 15 6'
  'draw button 21 7.03 0.45 0.90 0.40 speed'
  'set button  6 0 15 15 6 0 15 15 6'
  'draw button 22 7.70 0.45 0.30 0.40  -'
  'set button  6 0 15 15 6 0 15 15 6'
  'draw button 23 9.65 0.45 0.30 0.40  +'

  ict  = 1
  xpos = 8.05
  while (ict < 6)
    colnum  = _spdcol.ict
    if (_spdcol.ict = 6) 
      bgcol = 6
    else
      bgcol = 0
    endif
    bnum    = 23 + ict
    'set button '_spdcol.ict' 'bgcol' 15 15 '_spdcol.ict' 'bgcol' 15 15 6'
    'draw button 'bnum' 'xpos' 0.45 0.30 0.30 .'
    ict = ict + 1
    xpos = xpos + 0.3
  endwhile

return

*---------------------*
*
*---------------------*
function setspeed(button)

* This function is used to set the speed at which a loop will
* be done.  It also modifies the display on the menu to 
* indicate whether a faster or slower loop speed has been 
* chosen.

if (button = 23)

* make the looping go faster....

  if (_loopsp < 5)

    ict = 1
    while (ict < 6)
      _spdcol.ict  = 15
      ict = ict + 1
    endwhile

    _loopsp = _loopsp + 1
    _spdcol._loopsp  = 6
    _waittime = _waittime / 2
    rc = redomenu()
    say 'FASTER, waittime = '_waittime

  endif

else

* make the looping go slower....
  
  if (_loopsp > 1)

    ict = 1
    while (ict < 6)
      _spdcol.ict  = 15
      ict = ict + 1
    endwhile

    _loopsp = _loopsp - 1
    _spdcol._loopsp  = 6
    _waittime = _waittime * 2
    rc = redomenu()
    say 'SLOWER, waittime = '_waittime

  endif

endif

tmpcol  = _spdcol._loopsp

return

*---------------------*
*
*---------------------*
function rdstorm(infile)

* Read in the list of storms & dates from the input file.
* Put the storms and associated dates into a string that 
* will be displayed in a dropmenu.

  say 'At top of rdstorm, infile= 'infile

  nst = 0
  _stormlist = ""
  while (1)
    res = read(infile)
    rc  = sublin(res,1)
    if(rc != 0)
      if(rc = 2)
        say 'End of storms file: 'infile
        say nst' cases are available...'
        say ' '
        break
      endif
      if(rc = 1); say 'rc=1: OPEN ERROR FOR 'infile; endif
      if(rc = 8); say 'rc=8: 'infile' OPEN FOR WRITE ONLY'; endif
      if(rc = 9); say 'rc=9: I/O ERROR FOR 'infile; endif
      return 99
    endif
    nst = nst + 1
    _storm.nst = sublin(res,2)
    if (nst = 1)
      _stormlist = _stormlist%_storm.nst
    else
      _stormlist = _stormlist%" |"%_storm.nst
    endif
  endwhile

  _stormlist = _stormlist%" "

return

*---------------------*
*
*---------------------*
function filebox()
  _filestuff="Reinit | Clear | Print B&W Postscript | Print Color Postscript | Print Color GIF | Print Reverse Color GIF | Print Color PNG | Print Reverse Color PNG | Exit Script | - - - - - - - | EXIT GrADS "
  _filefunc.1="reit"
  _filefunc.2="clr"
  _filefunc.3="printbw"
  _filefunc.4="printcl"
  _filefunc.5="printgif"
  _filefunc.6="printrgif"
  _filefunc.7="printpng"
  _filefunc.8="printrpng"
  _filefunc.9="return"
  _filefunc.10="null"
  _filefunc.11="quit"
return

*---------------------*
*
*---------------------*
function readopts()
***  _optstuff="Set gxout contour| Set gxout shaded| Set gxout grid| Set gxout vector| Set gxout stream| Plot Highs & Lows| No Highs & Lows| Overlay Plots (for <display>)| Clear b4 plotting (for <display>)| Modify full domain Lat/Lon bounds| Use entire full domain Lat/Lon grid"
  _optstuff="Set gxout contour | Set gxout shaded | Set gxout grid | Set gxout vector | Set gxout stream | -- Inactive option | -- Inactive option | Overlay Plots (for <display>) | Clear b4 plotting (for <display>) | Modify full domain Lat/Lon bounds | Use entire full domain Lat/Lon grid | Modify inner-nest Lat/Lon bounds | Use full inner-nest grid "
  _optlist.1="gxcont"
  _optlist.2="gxshad"
  _optlist.3="gxgrid"
  _optlist.4="gxvect"
  _optlist.5="gxstream"
  _optlist.6="yeshilo"
  _optlist.7="nohilo"
  _optlist.8="overlay"
  _optlist.9="clearplot"
  _optlist.10="setbound"
  _optlist.11="origbound"
  _optlist.12="set_hi_bound"
  _optlist.13="orig_hi_bound"
return

*---------------------*
*
*---------------------*
function readopt2()
**  _opt2stuff="Set contour interval| Skip vectors| Mark fcst pos| Mark btrak pos| Plot full track| Plot track to now | Do NOT plot track"
  _opt2stuff="Set contour interval | Vectors spacing | Grid display spacing | Grid display digits | Grid display size | Mark fcst pos | -- Inactive option | Plot full track | Plot track to now | Do NOT plot track "
  _opt2list.1="setcint"
  _opt2list.2="vecspcing"
  _opt2list.3="grddispspcing"
  _opt2list.4="grddispdigits"
  _opt2list.5="grddispsize"
  _opt2list.6="markpos"
  _opt2list.7="markbtrk"
  _opt2list.8="fulltrak"
  _opt2list.9="nowtrak"
  _opt2list.10="notrak"
return

*---------------------*
*
*---------------------*
function readopt3()
  _opt3stuff="Temps in K | Temps in C | Temps in Fahr | Precip in inches | Precip in cm | Precip in mm | Winds in knots | Winds in m/s | Outer streamline density >10> | Inner streamline density >11> "
  _opt3list.1="tempsink"
  _opt3list.2="tempsinc"
  _opt3list.3="tempsinf"
  _opt3list.4="prcpinin"
  _opt3list.5="prcpincm"
  _opt3list.6="prcpinmm"
  _opt3list.7="windinkt"
  _opt3list.8="windinms"
  _opt3list.9="outstdens"
  _opt3list.10="instdens"

  _odensstr=""
  i = 1
  while (i <= 10)
    if (i = _outerdens)
      if (i < 10)
        _odensstr = _odensstr%" "%i%"* |"
      else
        _odensstr = _odensstr%" "%i%"* "
      endif
    else
      if (i < 10)
        _odensstr = _odensstr%" "%i%" |"
      else
        _odensstr = _odensstr%" "%i%" "
      endif
    endif
    i = i + 1
  endwhile 

  _idensstr=""
  i = 1
  while (i <= 10)
    if (i = _innerdens)
      if (i < 10)
        _idensstr = _idensstr%" "%i%"* |"
      else
        _idensstr = _idensstr%" "%i%"* "
      endif
    else
      if (i < 10)
        _idensstr = _idensstr%" "%i%" |"
      else
        _idensstr = _idensstr%" "%i%" "
      endif
    endif
    i = i + 1
  endwhile

return

*---------------------*
*                     *
*---------------------*
function readvpfl()
  _vpflstuff="Low res fixed x-section | Low res arb x-section | Hi res fixed x-section| Hi res arb x-section | Low res azimuthal average | Hi res azimuthal average | Low res point skew-t | Low res area skew-t | Hi res point skew-t | Hi res area skew-t | Low res simple profile | Hi res simple profile"
  _vpfllist.1="loresfixedcs"
  _vpfllist.2="loresarbitrarycs"
  _vpfllist.3="hiresfixedcs"
  _vpfllist.4="hiresarbitrarycs"
  _vpfllist.5="loresazimuthcs"
  _vpfllist.6="hiresazimuthcs"
  _vpfllist.7="loresskewt"
  _vpfllist.8="loresareaskewt"
  _vpfllist.9="hiresskewt"
  _vpfllist.10="hiresareaskewt"
  _vpfllist.11="loressimplevp"
  _vpfllist.12="hiressimplevp"
return

*---------------------*
*
*---------------------*
function openctl(item)

* This function will open the GrADS .ctl file for the
* storm that the user has selected.

* This if statement says that if we have already been
* plotting the track of a different storm (trakread = "done"),
* then we want to close that track file and vitals file in
* case the user would select that same storm again at some
* future point.  By closing the file, we essentially rewind
* it, so that the next time the user selects this storm, we
* will not hit an immediate EOF.

  if (_trakread = "done")
    rc = close(_vitfile)
    rc = close(_trakfile)
    _trakread  = "notyet"
  endif

  'reinit'
  
  'set font 4'

* First open the 1/6th degree, full-domain ctl files....

  atcf  = subwrd(_storm.item,1)
  idate = subwrd(_storm.item,2)

  thrddegctl = atcf%'.'%idate%'.6th.ctl'
  'open 'thrddegctl
  'run set_int_levs.gs'
  
* Pull out the X- and Y-dimension defaults for 
* reference later on.  You will need to save the 
* "maxorig" variables in case the user selects to
* return to the full grid lat/lon dimensions....

  'q file'
  rec = sublin(result,5)
  _xmaxorig = subwrd(rec,3)
  _ymaxorig = subwrd(rec,6)
  numtimes  = subwrd(rec,12)
  _xstart = 1
  _xend   = _xmaxorig
  _ystart = 1
  _yend   = _ymaxorig

* Now loop through and open all of the 
* 1/12th degree (inner nest) ctl files....

  itmp = 1
  while (itmp <= numtimes)
    ifhr = 6 * (itmp - 1)
    if (ifhr = 0); ifhr = '00'; endif
    if (ifhr = 6); ifhr = '06'; endif
    n3ctl = atcf%'.'%idate%'.f'%ifhr%'.ctl'
    
    'open 'n3ctl
    itmp = itmp + 1
  endwhile
  
  'set dfile 2'
  'set t 1'
  _rhbug = testrhbug()

  'set dfile 1'
  'set t 1'
  
  _fileflag = "open"
  _lastgraph = "clear"
  _dispvar = "none"

return

*---------------------*
*
*---------------------*
function gettimes()

* (1) Get maximum time dimension....

  'set dfile 1'
  'q file 1'
  rec = sublin(result,5)
  _timemax = subwrd(rec,12)

* (2) Get all the forecast time intervals.  These
*     forecast hours are displayed in a menu item.

  itmp = 1
  _fhrlist = ""

  while (itmp <= _timemax)
  
    _fcsthour.itmp = (itmp - 1) * 6

    if (_fcsthour.itmp = 0); _fcsthour.itmp = "00"; endif
    if (_fcsthour.itmp = 6); _fcsthour.itmp = "06"; endif

    if (itmp = 1)
      _fhrlist = _fhrlist%_fcsthour.itmp
    else
      _fhrlist = _fhrlist%" |"%_fcsthour.itmp
    endif

    itmp = itmp + 1

  endwhile

  _fhrlist = _fhrlist%" "

return

*---------------------*
*
*---------------------*
function readvars()

  'q file'
  rec = sublin(result,6)
  numvar = subwrd(rec,5)

  if (numvar = 0)
    return 99
  else

    got_u = 'n'
    got_v = 'n'
    itmp = 1
    Ltmp = 7
    _varlist = ""

    while (itmp <= numvar)

      tmplin    = sublin(result,Ltmp)
      _var.itmp = subwrd(tmplin,1)

*      say 'itmp= 'itmp'  var= '_var.itmp

      if (itmp = 1)
        _varlist = _varlist%_var.itmp
      else
        _varlist = _varlist%" |"%_var.itmp
      endif

      if (_var.itmp = 'u' | _var.itmp = 'U')
        got_u = 'y'
      endif

      if (_var.itmp = 'v' | _var.itmp = 'V')
        got_v = 'y'
      endif

      if (_var.itmp = 'u35' | _var.itmp = 'U35')
        got_u35 = 'y'
      endif

      if (_var.itmp = 'v35' | _var.itmp = 'V35')
        got_v35 = 'y'
      endif

      if (_var.itmp = 'u10' | _var.itmp = 'U10')
        got_u10 = 'y'
      endif

      if (_var.itmp = 'v10' | _var.itmp = 'V10')
        got_v10 = 'y'
      endif

      itmp = itmp + 1
      Ltmp = Ltmp + 1

    endwhile

  endif

  _var.itmp = ""
  _varlist = _varlist%" | ---- Derived ----"  
  

* If both u and v are available, then add another variable,
* which will be for plotting the vector winds.

  if (got_u = 'y' & got_v = 'y')
    itmp = itmp + 1
    _var.itmp = "Vector Wind"
    _varlist = _varlist%" |"%_var.itmp
  endif

* If both u35 and v35 are available, then add another variable,
* which will be for plotting the 35m vector winds.

  if (got_u35 = 'y' & got_v35 = 'y')
    itmp = itmp + 1
    _var.itmp = "35m Vector Wind"
    _varlist = _varlist%" |"%_var.itmp
  endif

* If both u10 and v10 are available, then add another variable,
* which will be for plotting the 10m vector winds.

  if (got_u10 = 'y' & got_v10 = 'y')
    itmp = itmp + 1
    _var.itmp = "10m Vector Wind"
    _varlist = _varlist%" |"%_var.itmp
  endif

* If both u and v are available, then add another variable,
* which will be for plotting the relative vorticity.

  if (got_u = 'y' & got_v = 'y')
    itmp = itmp + 1
    _var.itmp = "Relative Vorticity"
    _varlist = _varlist%" |"%_var.itmp
  endif

* Add another variable, which will be for displaying the 
* track only.

  itmp = itmp + 1
  _var.itmp = "Forecast Track Only"
  _varlist = _varlist%" |"%_var.itmp

* If both u35 and v35 are available, then add another variable,
* which will be for plotting the pmsl with a shaded plot of the
* magnitude of the 35m winds overlaid.


  if (got_u35 = 'y' & got_v35 = 'y')
    itmp = itmp + 1
    _var.itmp = "pmsl and 35m winds"
    _varlist = _varlist%" |"%_var.itmp
  endif

* If both u and v are available, then add another variable,
* which will be for plotting the vertical shear.

  if (got_u = 'y' & got_v = 'y')
    itmp = itmp + 1
    _var.itmp = "Vertical Shear"
    _varlist = _varlist%" |"%_var.itmp
  endif

* Add another variable for total accumulated precip (for 
* 1-day and full-run totals).

  itmp = itmp + 1
  _var.itmp = "Total Precip"
  _varlist = _varlist%" |"%_var.itmp
    
return

*---------------------*
*
*---------------------*
function pickvar(item)

* We chack the first character of the selected variable to see if it's a valid
* variable. If it isn't we set the display variable to "none" so the program
* catches it rather than crashing. 

  char = substr(_var.item,1,1)
  if (char = "" | char = "_")
    _dispvar = "none"
  else
    _dispvar = _var.item
  endif

*  say 'in pickvar, item= 'item'  dispvar= '_dispvar

  if (_dispvar = "Vertical Shear")

    say '*----------------------------------------------*'
    say '*                                              *'
    say '* VERTICAL SHEAR SELECTED AS VARIABLE....      *'
    say '*                                              *'
    say '*----------------------------------------------*'

*   Get user input for value of upper level....

    levuok = 'n'
    while (levuok = 'n')

      say '                                                '
      say '  Enter the value of the **UPPER** level '
      say '  (value should be a multiple of 50, '
      say '   between 1000 and 50 mb)'
      say '                                                '
      prompt '  ---> '

      pull ltmp

      say ' '

      if (ltmp > 0 & ltmp < 1050)
        modchk = mod(ltmp,50)
      else
        say '!!! BAD INPUT: VALUE NOT BETWEEN 0 AND 1000 mb. TRY AGAIN....'
        continue
      endif

      if (modchk = 0)
        levuok = 'y'
        _shrlevhi = ltmp
        say '+++ Upper Level selected is '_shrlevhi' mb'
      else
        say '!!! BAD INPUT: VALUE IS NOT A MULTIPLE OF 50.  TRY AGAIN....'
      endif

    endwhile

*   Get user input for value of lower level....

    levlok = 'n'
    while (levlok = 'n')

      say '                                                '
      say '  Enter the value of the **LOWER** level '
      say '  (value should be a multiple of 50, '
      say '   between 1000 and 50 mb)'
      say '                                                '
      prompt '  ---> '

      pull ltmp

      say ' '

      if (ltmp > 0 & ltmp < 1050)
        modchk = mod(ltmp,50)
      else
        say '!!! BAD INPUT: VALUE NOT BETWEEN 0 AND 1000 mb. TRY AGAIN....'
        continue
      endif

      if (modchk = 0)
        if (ltmp > _shrlevhi)
          levlok = 'y'
          _shrlevlo = ltmp
          say '+++ Lower Level selected is '_shrlevlo' mb'
        else
          say '!!! BAD INPUT: VALUE FOR THE LOWER LEVEL IS NOT LOWER '
          say '!!!            THAN THE VALUE YOU ENTERED FOR THE UPPER '
          say '!!!            LEVEL.  TRY AGAIN....'
        endif
      else
        say '!!! BAD INPUT: VALUE IS NOT A MULTIPLE OF 50.  TRY AGAIN....'
      endif

    endwhile

  endif

return

*---------------------*
*
*---------------------*
function picktime(item)

  'set dfile 1'
  'set t 'item

return

*---------------------*
*
*---------------------*
function pickopt(item)

  'q dims'
  rec = sublin(result,5)
  currtime = subwrd(rec,6)
  ctimeval = subwrd(rec,9)

  if (_optlist.item = "gxcont");   _gxplottyp = "contour"; endif
  if (_optlist.item = "gxshad");   _gxplottyp = "shaded"; endif
  if (_optlist.item = "gxvect")   
    _gxplottyp = "vector" 
    _gxwindtyp = "vector" 
  endif
  if (_optlist.item = "gxstream") 
    _gxplottyp = "stream" 
    _gxwindtyp = "stream" 
  endif
  if (_optlist.item = "gxgrid");   _gxplottyp = "grid"; endif
  if (_optlist.item = "yeshilo"); _plothilo = "yes"; endif
  if (_optlist.item = "nohilo");  _plothilo = "no"; endif
  if (_optlist.item = "overlay");   _clearplot = "no"; endif
  if (_optlist.item = "clearplot"); _clearplot = "yes"; endif

  if (_optlist.item = "setbound")
    if (_lastgraph = "clear")


      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot change the Lat/Lon boundaries yet."
      say "  !!!        The Lat/Lon boundaries are changed by clicking"
      say "  !!!        the mouse on the upper-left and lower-right"
      say "  !!!        boundaries in the plot on the left-hand side of"
      say "  !!!        the screen, but you have not plotted anything "
      say "  !!!        yet.  Select a storm and plot something first,"
      say "  !!!        and then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
    else

      boundsok = 'n'

      while (boundsok = 'n')

        say " "
        say "  *---------------------------------------------------*"
        say "  * Modify Lat/Lon Bounds:                            *"
        say "  *                                                   *"
        say "  *  Click on the point for your desired new upper-   *"
        say "  *  left hand point in the plot in the left window   *"
        say "  *  (this will be your new NW boundary point)....    *"

        'set gxout contour'
        'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
        'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
        'set black -99999999 99999999'
        'set grads off'
        'd pmsl'

*       The boundaries of the rband box have to be fudged a little
*       bit here, since the automatic boundaries returned from 
*       gxinfo do not match the boundaries of the plot....
       
        rbxl  = _gxinfox1
        rbxr  = _gxinfox2 - 0.30
        rbylo = _gxinfoy1 - 0.01
        rbyhi = _gxinfoy2 - 0.30

        'clear rband 30'
        'set rband 30 box 'rbxl' 'rbylo' 'rbxr' 'rbyhi
        'query pos'

        vpx1 = subwrd(result,3)
        vpx2 = subwrd(result,8)
        vpy1 = subwrd(result,4)
        vpy2 = subwrd(result,9)

        widgetclass = subwrd(result,6)
        if (widgetclass != 2)
*         User clicked outside of plot area.  Ignore and return....

          say '!!! YOU CLICKED OUTSIDE OF THE COARSE PLOT AREA.'
          say '!!! NOT GETTING WIDGETCLASS OF 2.   ZOOM IGNORED....'
          return
        endif

*       Since we're in a virtual page, convert the virtual x and y to the
*       regular page x and y....

        'q pp2xy 'vpx1' 'vpy1
        vprx1 = subwrd(result,3)
        vpry1 = subwrd(result,6)
        'q pp2xy 'vpx2' 'vpy2
        vprx2 = subwrd(result,3)
        vpry2 = subwrd(result,6)

        'q xy2w 'vprx1' 'vpry1
        rblon1 = subwrd(result,3)
        rblat1 = subwrd(result,6)
        'q xy2w 'vprx2' 'vpry2
        rblon2 = subwrd(result,3)
        rblat2 = subwrd(result,6)

        if (rblon1 = rblon2 | rblat1 = rblat2)
          return
        endif

        if (rblon1 < rblon2)
          lonwest = rblon1
          loneast = rblon2
        else
          lonwest = rblon2
          loneast = rblon1
        endif

        if (rblat1 < rblat2)
          latsouth = rblat1
          latnorth = rblat2
        else
          latsouth = rblat2
          latnorth = rblat1
        endif

        'q w2gr 'lonwest' 'latsouth
        _xstart = subwrd(result,3)
        _ystart = subwrd(result,6)

        'q w2gr 'loneast' 'latnorth
        _xend   = subwrd(result,3)
        _yend   = subwrd(result,6)

        'q gr2xy '_xstart' '_ystart
        nxstart = subwrd(result,3)
        nystart = subwrd(result,6)

        'q gr2xy '_xend' '_yend
        nxend = subwrd(result,3)
        nyend = subwrd(result,6)

        say '  *                                                   *'
        say '  * New boundaries:                                   *'
        say '  *       Lon: 'lonwest' 'loneast
        say '  *       Lat: 'latsouth' 'latnorth
        say '  *    grid x: '_xstart' '_xend
        say '  *    grid y: '_ystart' '_yend
        say '  *  window x: 'nxstart' 'nxend
        say '  *  window y: 'nystart' 'nyend
        say '  *'
        say "  *---------------------------------------------------*"

        boundsok = 'y'

        'set line 1 1 6'
        'draw rec 'nxstart' 'nystart' 'nxend' 'nyend
         
      endwhile

    endif
  endif


  if (_optlist.item = "set_hi_bound")
*    say "should be setting lat/lon"
    if (_lastgraph = "clear")
      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot change the Lat/Lon boundaries yet."
      say "  !!!        The Lat/Lon boundaries are changed by clicking"
      say "  !!!        the mouse on the upper-left and lower-right"
      say "  !!!        boundaries in the plot on the left-hand side of"
      say "  !!!        the screen, but you have not plotted anything "
      say "  !!!        yet.  Select a storm and plot something first,"
      say "  !!!        and then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
    else

      boundsok = 'n'

      while (boundsok = 'n')

        say " "
        say "  *---------------------------------------------------*"
        say "  * Modify INNER-NEST lat/lon bounds:                 *"
        say "  *                                                   *"
        say "  *  Click and drag for your desired new lat/lon      *"
        say "  *  boundaries in the left window                    *"
        say "  *                                                   *"

*       In order to be able to reference the frame on the right
*       side of our page as a "vpage", we need to first plot 
*       something in that window to sort of transfer vpage control
*       to that window.  To do this, just plot pmsl data with all
*       the values blacked out.

        'set dfile '_lasthrfn
        'set x '_inxstart' '_inxend
        'set y '_inystart' '_inyend
        'set gxout contour'
        'set time '_lasthrti
        'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
        'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
        'set black -99999999 99999999'
        'set grads off'
        'd pmsl'

        hrppxl = _invplft + _gxinf161
        hrppxr = _invplft + _gxinf162 - 0.22
        hrppylo = _invpbot + _gyinf161 - 0.16
        hrppyhi =  _invpbot + _gyinf162 - 0.34

        'clear rband 30'
        'set rband 30 box 'hrppxl' 'hrppylo' 'hrppxr' 'hrppyhi
        'query pos'

        vpx1 = subwrd(result,3)
        vpx2 = subwrd(result,8)
        vpy1 = subwrd(result,4)
        vpy2 = subwrd(result,9)

        widgetclass = subwrd(result,6)
        if (widgetclass != 2)
*         User clicked outside of plot area.  Ignore and return....
          say '!!! YOU CLICKED OUTSIDE OF THE INNER NEST PLOT AREA.'
          say '!!! NOT GETTING WIDGETCLASS OF 2.   ZOOM IGNORED....'
          'set dfile 1'
          'set x '_xstart' '_xend
          'set y '_ystart' '_yend
          'set time 'currtime
          return
        endif

*       Since we're in a virtual page, convert the virtual x and y to the
*       regular page x and y....

        'q pp2xy 'vpx1' 'vpy1
        vprx1 = subwrd(result,3)
        vpry1 = subwrd(result,6)

        'q pp2xy 'vpx2' 'vpy2
        vprx2 = subwrd(result,3)
        vpry2 = subwrd(result,6)

        'q xy2w 'vprx1' 'vpry1
        say result
        rblon1 = subwrd(result,3)
        rblat1 = subwrd(result,6)
        'q xy2w 'vprx2' 'vpry2
        say result
        rblon2 = subwrd(result,3)
        rblat2 = subwrd(result,6)

        if (rblon1 = rblon2 | rblat1 = rblat2)
          'set dfile 1'
          'set x '_xstart' '_xend
          'set y '_ystart' '_yend
          'set time 'currtime
          return
        endif

        if (rblon1 < rblon2)
          lonwest = rblon1
          loneast = rblon2
        else
          lonwest = rblon2
          loneast = rblon1
        endif

        if (rblat1 < rblat2)
          latsouth = rblat1
          latnorth = rblat2
        else
          latsouth = rblat2
          latnorth = rblat1
        endif

        'q w2gr 'lonwest' 'latsouth
        _inxstart = subwrd(result,3)
        _inystart = subwrd(result,6)

        'q w2gr 'loneast' 'latnorth
        _inxend   = subwrd(result,3)
        _inyend   = subwrd(result,6)

        'q gr2xy '_inxstart' '_inystart
        ixstart = subwrd(result,3)
        iystart = subwrd(result,6)

        'q gr2xy '_inxend' '_inyend
        ixend = subwrd(result,3)
        iyend = subwrd(result,6)

        say '  *                                                   *'
        say '  * New boundaries for inner-nest:                    *'
        say '  *       Lon: 'lonwest' 'loneast
        say '  *       Lat: 'latsouth' 'latnorth
        say '  *  window x: 'ixstart' 'ixend
        say '  *  window y: 'iystart' 'iyend
        say '  *    grid x: '_inxstart' '_inxend
        say '  *    grid y: '_inystart' '_inyend
        say '  *'
        say "  *---------------------------------------------------*"

        boundsok = 'y'

        'set line 1 1 6'
        'draw rec 'ixstart' 'iystart' 'ixend' 'iyend

        'set dfile 1'
        'set x '_xstart' '_xend
        'set y '_ystart' '_yend
        'set time 'currtime
        
      endwhile

    endif
  endif
  
  if (_optlist.item = "origbound")
    _xstart = 1
    _xend   = _xmaxorig
    _ystart = 1
    _yend   = _ymaxorig
  endif

  if (_optlist.item = "orig_hi_bound")
    _inxstart = _inxstart_def
    _inxend   = _inxend_def
    _inystart = _inystart_def
    _inyend   = _inyend_def
  endif

  if (_optlist.item = "overlay")
    _dispopt = "overlay"
  endif

  if (_optlist.item = "clearplot")
    _dispopt = "clearplot"
  endif

return

*---------------------*
*
*---------------------*
function pickopt2(item)

*  say 'In pickopt2, item = 'item
*  say 'In pickopt2, _opt2list.item = '_opt2list.item

  if (_opt2list.item = "setcint")
    say ' '
    say ' *--------------------------------------------*'
    say ' *                                            *'
    say ' *     ----  SET CONTOUR INTERVAL  ----       *'
    say ' *                                            *'
    say ' * At the prompt below, enter the new contour *'
    say ' * interval.  Current contour interval = '_defcint
    say ' *                                            *'
    say ' *--------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull _defcint

    say ' '
    say ' ++ New contour interval is '_defcint' ....'
    say ' '

  endif

  if (_opt2list.item = "vecspcing")
    say ' '
    say ' *--------------------------------------------*'
    say ' *                                            *'
    say ' *      ----  SET VECTOR SPACING  ----        *'
    say ' *                                            *'
    say ' * At the prompt below, enter the new vector  *'
    say ' * spacing value (in inches).                 *'
    say ' *                                            *'
    say ' * Just hitting return leaves it alone.       *'
    say ' *                                            *'
    say ' * Currently, the vector spacing value is     *'
    say ' * set to '_vecspcing
    say ' *                                            *'
    say ' *--------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull string

    if (string = '')
      _vecspcing = _vecspcing
    else
      _vecspcing = string
    endif

  endif
  
  if (_opt2list.item = "grddispspcing")
    say ' '
    say ' *--------------------------------------------*'
    say ' *                                            *'
    say ' *   ----  SET GRIDDED VALUES SPACING  ----   *'
    say ' *                                            *'
    say ' * At the prompt below, enter the spacing     *'
    say ' * (in inches) to use when plotting grid      *'
    say ' * values                                     *'
    say ' *                                            *'
    say ' * Just hitting return leaves it alone        *'
    say ' * alone.                                     *'
    say ' *                                            *'
    say ' * Currently, the grid data values spacing    *'
    say ' * is set to '_grdspcing
    say ' *                                            *'
    say ' *--------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull string

    if (string = '')
      _grdspcing = _grdspcing
    else
      _grdspcing = string
    endif
  endif
  
  if (_opt2list.item = "grddispdigits")
    say ' '
    say ' *--------------------------------------------*'
    say ' *                                            *'
    say ' *       ----  SET GRIDDED VALUES  ----       *'
    say ' *       ----  SIGNIFICANT DIGITS  ----       *'
    say ' *                                            *'
    say ' * At the prompt below, enter the number of   *'
    say ' * significant digits to display when         *' 
    say ' * plotting grid values.                      *'
    say ' *                                            *'
    say ' * Just hitting return leaves it alone        *'
    say ' * alone.                                     *'
    say ' *                                            *'
    say ' * Currently, the number of significant       *'
    say ' * digits is set to '_grdsigdig
    say ' *                                            *'
    say ' *--------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull string

    if (string = '')
      _grdsigdig = _grdsigdig
    else
      _grdsigdig = string
    endif
  endif

  if (_opt2list.item = "grddispsize")
    say ' '
    say ' *--------------------------------------------*'
    say ' *                                            *'
    say ' *     ----  SET GRID DISPLAY SIZE ----       *'
    say ' *                                            *'
    say ' * At the prompt below, enter the size you    *' 
    say ' * want data to display at when plotting      *' 
    say ' * grid values.                               *'
    say ' *                                            *'
    say ' * Just hitting return leaves it alone        *'
    say ' * alone.                                     *'
    say ' *                                            *'
    say ' * Currently, the grid display size is        *'
    say ' * set to '_grddigsiz
    say ' *                                            *'
    say ' *--------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull string

    if (string = '')
      _grddigsiz = _grddigsiz
    else
      _grddigsiz = string
    endif
  endif

  if (_opt2list.item = "fulltrak" | _opt2list.item = "nowtrak" | _opt2list.item = "markpos")
    if (_trakread = "notyet")
      rc = readtrak()
    endif
    if (_opt2list.item = "fulltrak")
      _trakopt = fulltrak
    endif
    if (_opt2list.item = "nowtrak")
      _trakopt = nowtrak
    endif
    if (_opt2list.item = "markpos")
      _trakopt = markpos
    endif
  endif

  if (_opt2list.item = "notrak")
    _trakopt = notrak
  endif

return

*---------------------*
*
*---------------------*
function pickopt3 (optstr)

  item = subwrd(optstr,8)
  btn10 = subwrd(optstr,10)

  if (_opt3list.item = "tempsink")
    _tempunit = "degk"
  endif
  if (_opt3list.item = "tempsinc")
    _tempunit = "degc"
  endif
  if (_opt3list.item = "tempsinf")
    _tempunit = "degf"
  endif
  
  if (_opt3list.item = "prcpinin")
    _prcpunit = "inches"
  endif
  if (_opt3list.item = "prcpincm")
    _prcpunit = "cm"
  endif
  if (_opt3list.item = "prcpinmm")
    _prcpunit = "mm"
  endif

  if (_opt3list.item = "windinkt")
    _windunit = "knots"
  endif
  if (_opt3list.item = "windinms")
    _windunit = "ms"
  endif

  if (_opt3list.item = "outstdens")
    _outerdens = btn10

    _odensstr=""
    i = 1
    while (i <= 10)
      if (i = _outerdens)
        if (i < 10)
          _odensstr = _odensstr%" "%i%"* |"
        else
          _odensstr = _odensstr%" "%i%"* "
        endif     
      else
        if (i < 10)
          _odensstr = _odensstr%" "%i%" |"
        else
          _odensstr = _odensstr%" "%i%" "
        endif
      endif
      i = i + 1
    endwhile
    rc = redomenu()
  endif

  if (_opt3list.item = "instdens")
    _innerdens = btn10

    _idensstr=""
    i = 1
    while (i <= 10)
      if (i = _innerdens)
        if (i < 10)
          _idensstr = _idensstr%" "%i%"* |"
        else
          _idensstr = _idensstr%" "%i%"* "
        endif
      else
        if (i < 10)
          _idensstr = _idensstr%" "%i%" |"
        else
          _idensstr = _idensstr%" "%i%" "
        endif
      endif
      i = i + 1
    endwhile
    rc = redomenu()
  endif

return

*---------------------*
*
*---------------------*
function pickvpfl(item)

* save the current time

  'q dims'
  rec = sublin(result,5)
  currtime = subwrd(rec,6)

* Here we set the variable and unit to pass to the cross section script 

  var = _dispvar
  unit = xxx

  if (_dispvar = "Vector Wind" | _dispvar = "Vertical Shear" | _dispvar = "35m Vector Wind" | _dispvar = "10m Vector Wind" | _dispvar = "pmsl and 35m winds")
    var = "windmag"
    unit = _windunit
  endif
  
  if (_dispvar = "u" | _dispvar = "v")
    unit = _windunit
  endif
  
  if (_dispvar = "t")
    unit = _tempunit
  endif
  
  if (_vpfllist.item = "loresfixedcs" | _vpfllist.item = "loresarbitrarycs")
  
* A cross section from the left (1/6 degree) panel was selected 
  
    if (_lastgraph = "clear")
      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot select a cross section yet. The cross"
      say "  !!!        section location is selected by clicking and"
      say "  !!!        dragging the mouse on the plotted area, but you"
      say "  !!!        have not plotted anything yet. Select a storm and"
      say "  !!!        plot something first, then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
      return
    endif
    
*  Draw a blank display (map only) over the left hand plot area.  This sets the virtual page control
*  to the left hand display so conversions will work even if the user has done something to change the
*  virtual page control to the right hand side (for instance zooming in on the right).
    
    'set gxout contour'
    'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
    'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
    'set black -99999999 99999999'
    'set grads off'
    'd pmsl'
    
* adjust the rband bounds so they look centered    
    
    rbxl = _gxinfox1
    rbxr = _gxinfox2 - 0.30
    rbyb = _gxinfoy1 - 0.01
    rbyt = _gxinfoy2 - 0.30
  
    'clear rband 30'
    'set rband 30 line 'rbxl' 'rbyb' 'rbxr' 'rbyt
    'q pos'
    
    vpx1 = subwrd(result,3)
    vpx2 = subwrd(result,8)
    vpy1 = subwrd(result,4)
    vpy2 = subwrd(result,9)

    widgetclass = subwrd(result,6)
    
    if (widgetclass != 2)
*   User clicked outside of plot area.  Ignore and return....

      say '!!! YOU CLICKED OUTSIDE OF THE COARSE PLOT AREA.'
      say '!!! NOT GETTING WIDGETCLASS OF 2.'
      return
    endif

    'q pp2xy 'vpx1' 'vpy1
    vprx1 = subwrd(result,3)
    vpry1 = subwrd(result,6)
    
    'q pp2xy 'vpx2' 'vpy2
    vprx2 = subwrd(result,3)
    vpry2 = subwrd(result,6)
    
    'q xy2w 'vprx1' 'vpry1
    rblon1 = subwrd(result,3)
    rblat1 = subwrd(result,6)
        
    'q xy2w 'vprx2' 'vpry2  
    rblon2 = subwrd(result,3)
    rblat2 = subwrd(result,6)
  
    if (_vpfllist.item = "loresfixedcs")
      
* If we have a fixed cross section set, see which is larger, the lon variation or the lat variation.
* If the former, set the latitude on both ends of the cross section to the first latitude the user
* clicked.  If the latter, set the longitude on both ends to the first longitude the user clicked.
* The bounds also get swapped so that W is always on the left for E-W x-section and S is always on the left
* for N-S x-section.
      
      if ( math_abs(rblon2-rblon1) > math_abs(rblat2-rblat1) )
      
        lat1 = rblat1
        lat2 = rblat1
        if (rblon2 > rblon1)
          lon2 = rblon2
          lon1 = rblon1
        else
          lon2 = rblon1
          lon1 = rblon2
        endif

      else

        lon1 = rblon1  
        lon2 = rblon1
        if (rblat2 > rblat1)
          lat2 = rblat2
          lat1 = rblat1
        else
          lat2 = rblat1
          lat1 = rblat2
        endif

      endif

    else
    
* If the cross section is arbitrary, the left side is the first point clicked and the right side is the second
    
      lon1 = rblon1
      lat1 = rblat1
      lon2 = rblon2
      lat2 = rblat2
      
    endif
    
    'q w2gr 'lon1' 'lat1
    xstart = subwrd(result,3)
    ystart = subwrd(result,6)
    
    'q w2gr 'lon2' 'lat2
    xend = subwrd(result,3)
    yend = subwrd(result,6)
    
    'q gr2xy 'xstart' 'ystart
    nxstart = subwrd(result,3)
    nystart = subwrd(result,6)
    
    'q gr2xy 'xend' 'yend
    nxend = subwrd(result,3)
    nyend = subwrd(result,6)
  
    'set line 1 1 6'
    'draw line 'nxstart' 'nystart' 'nxend' 'nyend
       
    parmstring = _userid' '_stormid' '_itime' '_pfhour' 6thdeg 'lat1' 'lon1' 'lat2' 'lon2' 'var' 'unit

* Here is where a seperate terminal is started up as another process. 
* A small shell script called when this new terminal starts up. It's 
* passed the set of parameters which need to be included when hurplot_xsect.gs
* is called.

    '!/usr/bin/rxvt -sb -geometry 80x24 -title "Cross Section Shell" -e "launch_xsect.sh" "'parmstring'" &'
     
  endif
  
  if ( _vpfllist.item = "hiresfixedcs" | _vpfllist.item = "hiresarbitrarycs" )
    
    if (_lastgraph = "clear")
      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot select a cross section yet. The cross"
      say "  !!!        section location is selected by clicking and"
      say "  !!!        dragging the mouse on the plotted area, but you"
      say "  !!!        have not plotted anything yet. Select a storm and"
      say "  !!!        plot something first, then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
      return
    endif
    
    
        
    'set dfile '_lasthrfn
    'set x '_inxstart' '_inxend
    'set y '_inystart' '_inyend
    'set gxout contour'
    'set time '_lasthrti
    'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
    'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
    'set black -99999999 99999999'
    'set grads off'
    'd pmsl'
        
    rbxl = _invplft + _gxinf161
    rbxr = _invplft + _gxinf162 - 0.22
    rbyb = _invpbot + _gyinf161 - 0.16
    rbyt = _invpbot + _gyinf162 - 0.34
  
    'clear rband 30'
    'set rband 30 line 'rbxl' 'rbyb' 'rbxr' 'rbyt
    'q pos'
  
    vpx1 = subwrd(result,3)
    vpx2 = subwrd(result,8)
    vpy1 = subwrd(result,4)
    vpy2 = subwrd(result,9)
    
    widgetclass = subwrd(result,6)
    
    if (widgetclass != 2)
*   User clicked outside of plot area.  Ignore and return....

      say '!!! YOU CLICKED OUTSIDE OF THE FINE PLOT AREA.'
      say '!!! NOT GETTING WIDGETCLASS OF 2.'
      return
    endif
    
    'q pp2xy 'vpx1' 'vpy1
    vprx1 = subwrd(result,3)
    vpry1 = subwrd(result,6)
    
    'q pp2xy 'vpx2' 'vpy2
    vprx2 = subwrd(result,3)
    vpry2 = subwrd(result,6)
    
    'q xy2w 'vprx1' 'vpry1
    rblon1 = subwrd(result,3)
    rblat1 = subwrd(result,6)
        
    'q xy2w 'vprx2' 'vpry2  
    rblon2 = subwrd(result,3)
    rblat2 = subwrd(result,6)
  
    if (_vpfllist.item = "hiresfixedcs")
      
      if ( math_abs(rblon2-rblon1) > math_abs(rblat2-rblat1) )
      
        lat1 = rblat1
        lat2 = rblat1
        if (rblon2 > rblon1)
          lon2 = rblon2
          lon1 = rblon1
        else
          lon2 = rblon1
          lon1 = rblon2
        endif

      else

        lon1 = rblon1  
        lon2 = rblon1
        if (rblat2 > rblat1)
          lat2 = rblat2
          lat1 = rblat1
        else
          lat2 = rblat1
          lat1 = rblat2
        endif

      endif

    else
    
      lon1 = rblon1
      lat1 = rblat1
      lon2 = rblon2
      lat2 = rblat2
      
    endif
  
    'q w2gr 'lon1' 'lat1
    xstart = subwrd(result,3)
    ystart = subwrd(result,6)
    
    'q w2gr 'lon2' 'lat2
    xend = subwrd(result,3)
    yend = subwrd(result,6)
    
    'q gr2xy 'xstart' 'ystart
    nxstart = subwrd(result,3)
    nystart = subwrd(result,6)
    
    'q gr2xy 'xend' 'yend
    nxend = subwrd(result,3)
    nyend = subwrd(result,6)
  
    'set line 1 1 6'
    'draw line 'nxstart' 'nystart' 'nxend' 'nyend
       
    parmstring = _userid' '_stormid' '_itime' '_pfhour' 12thdeg 'lat1' 'lon1' 'lat2' 'lon2' 'var' 'unit
    
    '!/usr/bin/rxvt -sb -geometry 80x24 -title "Cross Section Shell" -e "launch_xsect.sh" "'parmstring'" &'

  endif
  
  if (_vpfllist.item = "loresazimuthcs" | _vpfllist.item = "hiresazimuthcs")
  
    if (_lastgraph = "clear")
      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot do an azimuthal section yet. Select" 
      say "  !!! a storm and plot something first, then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
      return
    endif
  
    if (_vpfllist.item = "loresazimuthcs")
    
      resflag = lores
      'set gxout contour'
      'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
      'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'
      
      xmin = _gxinfox1
      xmax = _gxinfox2
      ymin = _gxinfoy1
      ymax = _gxinfoy2
      
    else
    
      resflag = hires
      'set dfile '_lasthrfn
      'set x '_inxstart' '_inxend
      'set y '_inystart' '_inyend
      'set gxout contour'
      'set time '_lasthrti
      'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
      'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'
            
      xmin = _gxinf161
      xmax = _gxinf162
      ymin = _gyinf161
      ymax = _gyinf162
      
    endif

    'q pos'
    
    vpx = subwrd(result,3)
    vpy = subwrd(result,4)
                
    'q pp2xy 'vpx' 'vpy
    px = subwrd(result,3)
    py = subwrd(result,6)
    
    xlo = px - 0.05
    xhi = px + 0.05
    ylo = py - 0.05
    yhi = py + 0.05

*   Draw an 'X' exactly where the user clicked
    
*    'set line 1 1 5'
*    'draw line 'xlo' 'py' 'xhi' 'py
*    'draw line 'px' 'ylo' 'px' 'yhi

    'draw mark 6 'px' 'py' 0.12'
       
    if (px <= xmin | px >= xmax | py <= ymin | py >= ymax) 
*   User clicked outside of plot area.  Ignore and return....

      say '!!! YOU CLICKED OUTSIDE OF THE PLOT AREA.'
      return
      
    endif

    'q xy2w 'px' 'py
    lon = subwrd(result,3)
    lat = subwrd(result,6)

    say '+++ Before findctr, user-clicked lon= 'lon'  lat= 'lat

    'q dims'
    xline = sublin(result,2)
    yline = sublin(result,3)
    xbeghold = subwrd(xline,11)
    xendhold = subwrd(xline,13)
    ybeghold = subwrd(yline,11)
    yendhold = subwrd(yline,13)

    xbeghold = math_int(xbeghold+0.5)
    xendhold = math_int(xendhold+0.5)
    ybeghold = math_int(ybeghold+0.5)
    yendhold = math_int(yendhold+0.5)

*   Before calling the findctr UDF, we want to set the
*   dimensions to be for the full dimensions of the grid.  This
*   way, the UDF has available the full grid of data on which
*   to search.  A GrADS bug (pointed out by Marshall) reared
*   its ugly head here, however.  In the statements below, if
*   we just did a "set x 1 xendfull", there were some cases
*   where a 'q dims' indicated that instead of x going from
*   1 to 60, it was going from 1 to 60.0002, and then when
*   GrADS would create the function transfer file, it would
*   automatically bump up the second argument, so we'd end up
*   passing in an incorrect x-dimension of 61 instead of 60.
*   Interestingly, the first argument (the 1) would get
*   truncated *down*.  Therefore, I fudged this 'set x'
*   statement by setting the first argument just greater than
*   1 and the second argument just less than xendfull.

    'q file'
    xyline = sublin(result,5)
    xendfull = subwrd(xyline,3)
    yendfull = subwrd(xyline,6)

    xendfudge = xendfull - 0.1
    yendfudge = yendfull - 0.1

    'set x 1.1 'xendfudge
    'set y 1.1 'yendfudge

    'define dummy = findctr('pmsl','lon','lat','min','pmsl','resflag')'
    'undefine dummy'

    'set x 'xbeghold' 'xendhold
    'set y 'ybeghold' 'yendhold

*   The center point has been written out to a text file.  We 
*   need to read that text file to get the lat/lon coordinates
*   for the center position....

    fixfile = _filedir%udf.fixfile.txt

    res = read(fixfile)
    rc  = sublin(res,1)
    if(rc != 0)
      if(rc = 2)
        say "rc=2: END OF "fixfile
      endif
      if(rc = 1); say 'rc=1: OPEN ERROR FOR 'fixfile; endif
      if(rc = 8); say 'rc=8: 'fixfile' OPEN FOR WRITE ONLY'; endif
      if(rc = 9); say 'rc=9: I/O ERROR FOR 'fixfile; endif
    else
      rec = sublin(res,2)
      fixlon = subwrd(rec,2)
      fixlat = subwrd(rec,4)
    endif

    rc = close(fixfile)

    'q w2xy 'fixlon' 'fixlat
    xfix = subwrd(result,3)
    yfix = subwrd(result,6)

    'set line 1 1 5'
    'draw mark 1 'xfix' 'yfix' 0.20'

    say 'After fixfile read, fixlon= 'fixlon'  fixlat= 'fixlat
    
    say ' '
    say ' *-------------------------------------------------*'
    say ' *                                                 *'
    say ' *  Select the distance, in kilometers, you want   *'
    say ' *  the cross-section to extend from the center of *'
    say ' *  the storm.                                     *'
    say ' *                                                 *'
    say ' *-------------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull string
    range = string / 111.177
    
    say ' '
    say ' *-------------------------------------------------*'
    say ' *                                                 *'
    say ' *  Select the left (counter-clockwise) side of    *'
    say ' *  the storm quadrant (in whole degrees 0-360)    *'
    say ' *  you want to average over azimuthally.          *' 
    say ' *                                                 *'
    say ' *  Note: If you want a full 360 degree average,   *'
    say ' *  enter 0 here.                                  *'
    say ' *                                                 *'
    say ' *-------------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull string
    startaz = math_nint(string)
    if (startaz < 100)
      startaz = '0'%startaz  
      if (startaz < 10)
        startaz = '0'%startaz
      endif
    endif
    
    say ' '
    say ' *-------------------------------------------------*'
    say ' *                                                 *'
    say ' *  Select the right (clockwise) side of the storm *'
    say ' *  quadrant (in whole degrees 0-360) you want to  *'
    say ' *  average over azimuthally.                      *' 
    say ' *                                                 *'
    say ' *  Note: If you want a full 360 degree average,   *'
    say ' *  enter 360 here.                                *'
    say ' *                                                 *'
    say ' *-------------------------------------------------*'
    say ' '
    prompt ' ---> '

    pull string
    endaz = math_nint(string)
    if (endaz < 100)
      endaz = '0'%endaz  
      if (endaz < 10)
        endaz = '0'%endaz
      endif
    endif
    
    quad = startaz%endaz
                    
    if (resflag = "lores")
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 6thdeg 'fixlat' 'fixlon' 'range' 'quad' 'var' 'unit' azimuthal'
    else
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 12thdeg 'fixlat' 'fixlon' 'range' 'quad' 'var' 'unit' azimuthal'
    endif
        
    '!/usr/bin/rxvt -sb -geometry 80x24 -title "Cross Section Shell" -e "launch_xsect.sh" "'parmstring'" &'
    
  endif
  
  if (_vpfllist.item = "loresskewt" | _vpfllist.item = "hiresskewt")
  
    if (_lastgraph = "clear")
      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot plot a skew-t diagram section yet. Select" 
      say "  !!! a storm and plot something first, then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
      return
    endif
    
    if (_vpfllist.item = "loresskewt")
    
      'set gxout contour'
      'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
      'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'
      
      xmin = _gxinfox1
      xmax = _gxinfox2
      ymin = _gxinfoy1
      ymax = _gxinfoy2
      
    else
    
      'set dfile '_lasthrfn
      'set x '_inxstart' '_inxend
      'set y '_inystart' '_inyend
      'set gxout contour'
      'set time '_lasthrti
      'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
      'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'
      
      xmin = _gxinf161
      xmax = _gxinf162
      ymin = _gyinf161
      ymax = _gyinf162
      
    endif
    
    'q pos'
    
    vpx = subwrd(result,3)
    vpy = subwrd(result,4)
                
    'q pp2xy 'vpx' 'vpy
    px = subwrd(result,3)
    py = subwrd(result,6)
    
    xlo = px - 0.05
    xhi = px + 0.05
    ylo = py - 0.05
    yhi = py + 0.05

*   Draw a plus sign exactly where the user clicked
    
    'set line 1 1 5'
    'draw line 'xlo' 'py' 'xhi' 'py
    'draw line 'px' 'ylo' 'px' 'yhi
       
    if (px <= xmin | px >= xmax | py <= ymin | py >= ymax) 
*   User clicked outside of plot area.  Ignore and return....

      say '!!! YOU CLICKED OUTSIDE OF THE PLOT AREA.'
      return
      
    endif

    'q xy2w 'px' 'py
    lon = subwrd(result,3)
    lat = subwrd(result,6)

*   'lat' and 'lon' are the latitude and longitude where the user clicked.
*   However, when the set lat/lon command is issued, the nearest grid point lat/lon
*   coordinate is used.  These coordinates, marked with an x, are what is actually 
*   used to create the skew-t plot.
                  
    'set lat 'lat
    'set lon 'lon
    'q dims'
                
    rec = sublin(result,2)
    xltg = subwrd(rec,9)
    rec = sublin(result,3)
    yltg = subwrd(rec,9)

    'q gr2w 'xltg' 'yltg
    lonltg = subwrd(result,3)
    latltg = subwrd(result,6)
       
    'q gr2xy 'xltg' 'yltg
    pxltg = subwrd(result,3)
    pyltg = subwrd(result,6)
        
    xlo = pxltg - 0.05
    xhi = pxltg + 0.05
    ylo = pyltg - 0.05
    yhi = pyltg + 0.05
    
    'set line 1 1 5'
    'draw line 'xlo' 'ylo' 'xhi' 'yhi
    'draw line 'xlo' 'yhi' 'xhi' 'ylo
        
    if (_vpfllist.item = "loresskewt")
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 6thdeg 'lonltg' 'latltg' 'lonltg' 'latltg
    else
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 12thdeg 'lonltg' 'latltg' 'lonltg' 'latltg
    endif
      
    '!/usr/bin/rxvt -sb -geometry 80x24 -title "Skew-T Shell" -e "launch_skewt.sh" "'parmstring'" &'   
  endif
  
  if (_vpfllist.item = "loresareaskewt" | _vpfllist.item = "hiresareaskewt")
 
    if (_lastgraph = "clear")
      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot plot a skew-t diagram section yet. Select" 
      say "  !!! a storm and plot something first, then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
      return
    endif
    
    if (_vpfllist.item = "loresareaskewt")
    
      'set gxout contour'
      'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
      'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'
      
      xmin = _gxinfox1
      xmax = _gxinfox2 - 0.30
      ymin = _gxinfoy1 - 0.01
      ymax = _gxinfoy2 - 0.30
      
    else
    
      'set dfile '_lasthrfn
      'set x '_inxstart' '_inxend
      'set y '_inystart' '_inyend
      'set gxout contour'
      'set time '_lasthrti
      'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
      'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'
               
      xmin = _invplft + _gxinf161
      xmax = _invplft + _gxinf162 - 0.22
      ymin = _invpbot + _gyinf161 - 0.16
      ymax = _invpbot + _gyinf162 - 0.34
      
    endif
    
    'clear rband 30'
    'set rband 30 box 'xmin' 'ymin' 'xmax' 'ymax
    'q pos'
    
    vpx1 = subwrd(result,3)
    vpy1 = subwrd(result,4)
    vpx2 = subwrd(result,8)
    vpy2 = subwrd(result,9)
    
    widgetclass = subwrd(result,6)
    if (widgetclass != 2) 
*   User clicked outside of plot area.  Ignore and return....
      say '!!! YOU CLICKED OUTSIDE OF THE PLOT AREA.'
      return
    endif
                
    'q pp2xy 'vpx1' 'vpy1
    px1 = subwrd(result,3)
    py1 = subwrd(result,6)
    
    'q pp2xy 'vpx2' 'vpy2
    px2 = subwrd(result,3)
    py2 = subwrd(result,6)
               
    'q xy2w 'px1' 'py1
    lon1 = subwrd(result,3)
    lat1 = subwrd(result,6)
    
    'q xy2w 'px2' 'py2
    lon2 = subwrd(result,3)
    lat2 = subwrd(result,6)
    
    'q w2gr 'lon1' 'lat1
    x1 = subwrd(result,3)
    y1 = subwrd(result,6)
    
    'q w2gr 'lon2' 'lat2
    x2 = subwrd(result,3)
    y2 = subwrd(result,6)
    
    if (x1 < x2)
      xlft = x1
      xrgt = x2
    else
      xlft = x2
      xrgt = x1
    endif
    
    if (y1 < y2)
      ybot = y1
      ytop = y2
    else
      ybot = y2
      ytop = y1
    endif
    
    'q gr2w 'xlft' 'ybot
    wlon = subwrd(result,3)
    slat = subwrd(result,6)
    
    'q gr2w 'xrgt' 'ytop
    elon = subwrd(result,3)
    nlat = subwrd(result,6)
        
    'q gr2xy 'xlft' 'ybot
    pxlft = subwrd(result,3)
    pybot = subwrd(result,6)
    
    'q gr2xy 'xrgt' 'ytop
    pxrgt = subwrd(result,3)
    pytop = subwrd(result,6)
    
    'set line 1 1 6'
    'draw rec 'pxlft' 'pybot' 'pxrgt' 'pytop
        
    if (_vpfllist.item = "loresareaskewt")
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 6thdeg 'wlon' 'slat' 'elon' 'nlat
    else
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 12thdeg 'wlon' 'slat' 'elon' 'nlat
    endif
      
    '!/usr/bin/rxvt -sb -geometry 80x24 -title "Skew-T Shell" -e "launch_skewt.sh" "'parmstring'" &'   
  endif

* These new options for a simple vertical profile ("simplevp") were added
* in April, 2007.

  if (_vpfllist.item = "loressimplevp" | _vpfllist.item = "hiressimplevp")

    if (_lastgraph = "clear")
      say " "
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say "  !!!"
      say "  !!! ERROR: You cannot plot a vertical profile yet. Select"
      say "  !!! a storm and plot something first, then try this option again."
      say "  !!!"
      say "  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      say " "
      return
    endif

    if (_vpfllist.item = "loressimplevp")

      'set gxout contour'
      'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
      'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'

      xmin = _gxinfox1
      xmax = _gxinfox2
      ymin = _gxinfoy1
      ymax = _gxinfoy2

    else

      'set dfile '_lasthrfn
      'set x '_inxstart' '_inxend
      'set y '_inystart' '_inyend
      'set gxout contour'
      'set time '_lasthrti
      'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
      'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
      'set black -99999999 99999999'
      'set grads off'
      'd pmsl'

      xmin = _gxinf161
      xmax = _gxinf162
      ymin = _gyinf161
      ymax = _gyinf162

    endif

    'q pos'

    vpx = subwrd(result,3)
    vpy = subwrd(result,4)

    'q pp2xy 'vpx' 'vpy
    px = subwrd(result,3)
    py = subwrd(result,6)

    xlo = px - 0.05
    xhi = px + 0.05
    ylo = py - 0.05
    yhi = py + 0.05

*   Draw a plus sign exactly where the user clicked

    'set line 1 1 5'
    'draw line 'xlo' 'py' 'xhi' 'py
    'draw line 'px' 'ylo' 'px' 'yhi

    if (px <= xmin | px >= xmax | py <= ymin | py >= ymax)
*   User clicked outside of plot area.  Ignore and return....

      say '!!! YOU CLICKED OUTSIDE OF THE PLOT AREA.'
      return

    endif

    'q xy2w 'px' 'py
    lon = subwrd(result,3)
    lat = subwrd(result,6)

*   'lat' and 'lon' are the latitude and longitude where the user clicked.
*   However, when the set lat/lon command is issued, the nearest grid point lat/lon
*   coordinate is used.  These coordinates, marked with an x, are what is actually
*   used to create the vertical profile.

    'set lat 'lat
    'set lon 'lon
    'q dims'

    rec = sublin(result,2)
    xltg = subwrd(rec,9)
    rec = sublin(result,3)
    yltg = subwrd(rec,9)

    'q gr2w 'xltg' 'yltg
    lonltg = subwrd(result,3)
    latltg = subwrd(result,6)

    'q gr2xy 'xltg' 'yltg
    pxltg = subwrd(result,3)
    pyltg = subwrd(result,6)

    xlo = pxltg - 0.05
    xhi = pxltg + 0.05
    ylo = pyltg - 0.05
    yhi = pyltg + 0.05

    'set line 1 1 5'
    'draw line 'xlo' 'ylo' 'xhi' 'yhi
    'draw line 'xlo' 'yhi' 'xhi' 'ylo

    if (_vpfllist.item = "loressimplevp")
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 6thdeg 'latltg' 'lonltg' 'latltg' 'lonltg' 'var' 'unit' simplevp'
    else
      parmstring = _userid' '_stormid' '_itime' '_pfhour' 12thdeg 'latltg' 'lonltg' 'latltg' 'lonltg' 'var' 'unit' simplevp'
    endif

    '!/usr/bin/rxvt -sb -geometry 80x24 -title "Cross Section Shell" -e "launch_xsect.sh" "'parmstring'" &'
  endif
  
* set file and dimensions back to previous values
  
  'set dfile 1'
  'set x '_xstart' '_xend
  'set y '_ystart' '_yend
  'set time 'currtime
  
return

*---------------------*
*
*---------------------*
function markpos(fcstlon,fcstlat,pttyp)

stalon = fcstlon * -1
*say 'stalon= 'stalon

'query ll2xy 'stalon' 'fcstlat
xdum=sublin(result,1)
xlon = subwrd(xdum,1)
xlat = subwrd(xdum,2)

'set string 1 c 6 0'
'set strsiz 0.2 0.2'
if (pttyp = 'fcst')
  'draw string 'xlon' 'xlat' x'
else
  'draw mark 1 'xlon' 'xlat' '0.12
  'draw mark 2 'xlon' 'xlat' '0.12
endif

return

*---------------------*
*
*---------------------*
function readlevs()

  'q file'
  rec = sublin(result,5)
  zmax = subwrd(rec,9)

  if (zmax = 0)
    return 99
  else

    itmp = 1
    _levlist = ""

    while (itmp <= zmax)

      'set z 'itmp
      _lev.itmp = subwrd(result,4) 
*      say 'itmp= 'itmp'  lev= '_lev.itmp

      if (itmp = 1)
        _levlist = _levlist%_lev.itmp
      else
        _levlist = _levlist%" |"%_lev.itmp
      endif

      itmp = itmp + 1

    endwhile

  endif

_levlist = _levlist%" "

* Set the level to the default display level....

  'set lev '_displev

return

*---------------------*
*
*---------------------*
function picklev(item)

  _displev = _lev.item
  'set lev '_displev

return

*---------------------*
*
*---------------------*
function readtrak()

* This function reads the lat, lon, windspeed and mslp
* data for each hour from the stats.complete file.  The
* the first record that is read is for hour 1, the second
* is for hour 2, and so on.  The hour 0 data are not
* included in the stats.complete file, so we will instead
* read the initial position from the vitals file.  So the
* first order of business is to construct the name of the 
* vitals file.  Then we read it for the hour 0 position,
* then we read the stats.complete file for the remaining
* forecast positions.

* Construct the TC vitals file name....

  'q file 1'
  rec = sublin(result,1)
  stormenv = subwrd(rec,9)
  ymdh     = subwrd(rec,10)

  cchar = substr(stormenv,1,1)
  ict = 1
  while (cchar != '')
    ict = ict + 1
    cchar = substr(stormenv,ict,1)
*    say 'ict= 'ict'  cchar= 'cchar
  endwhile

  sct = ict - 3
  bct = ict - 1
  stnum = substr(stormenv,sct,2)
  basid = substr(stormenv,bct,1)
  yy    = substr(ymdh,3,2)
  yymmddhh = substr(ymdh,3,8)

*  say 'stnum= 'stnum'  basid= 'basid'  yy= 'yy

  if (basid = 'l' | basid = 'L')
    basin = "AL"
  endif
  if (basid = 'e' | basid = 'E')
    basin = "EP"
  endif
  if (basid = 'c' | basid = 'C')
    basin = "CP"
  endif

  _vitfile = basin%stnum%yy'.vitals.'%yymmddhh
  say ' '
  say 'Reading initial position from vitals file: '_vitfile

* Now, read the TC vitals file....

  nhr = 0
  res = read(_vitfile)
  rc  = sublin(res,1)
  if(rc != 0)
    if(rc = 2)
      say "rc=2: END OF "_vitfile
    endif
    if(rc = 1); say 'rc=1: OPEN ERROR FOR '_vitfile; endif
    if(rc = 8); say 'rc=8: '_vitfile' OPEN FOR WRITE ONLY'; endif
    if(rc = 9); say 'rc=9: I/O ERROR FOR '_vitfile; endif
  else
    rec = sublin(res,2)
    _lat.nhr     = substr(rec,32,3)/10
    _lon.nhr     = substr(rec,37,4)/10 * -1
    _windspd.nhr = 0
    _mslp.nhr    = 0
    _maxtrak     = nhr
  endif

  latinit = _lat.0
  loninit = _lon.0
*  say 'latinit= 'latinit'  loninit= 'loninit

* Now construct the stats.complete file name and read
* the track from it....

  'q file 1'
  rec = sublin(result,1)
  stormenv = subwrd(rec,9)
  ymdh     = subwrd(rec,10)
  _trakfile=stormenv%"."%ymdh%".stats.complete"

  nhr = 0
  while (1)
    res = read(_trakfile)
    rc  = sublin(res,1)
    if(rc != 0)
      if(rc = 2)
        say "End of stats.complete track file: "_trakfile
        say nhr" forecast hours are available..."
        say ' '
        break
      endif
      if(rc = 1); say 'rc=1: OPEN ERROR FOR '_trakfile; endif
      if(rc = 8); say 'rc=8: '_trakfile' OPEN FOR WRITE ONLY'; endif
      if(rc = 9); say 'rc=9: I/O ERROR FOR '_trakfile; endif
      return 99
    endif
    nhr = nhr + 1
    rec = sublin(res,2)
    _lon.nhr     = subwrd(rec,2)
    _lat.nhr     = subwrd(rec,3)
    _windspd.nhr = subwrd(rec,4)
    _mslp.nhr    = subwrd(rec,6)
    _maxtrak     = nhr
  endwhile

  _trakread = "done"

* Set the initial windspeed equal to the windspeed at hour1, since
* the windspeed at hour 0 came from the vitals file, while all 
* subsequent windspeeds, including that at hour1, come from the
* GFDL forecast, and we want these to be somewhat consistent....

  _windspd.0 = _windspd.1

return

*---------------------*
*
*---------------------*
function plottrak(timeval)

currhour = (timeval - 1) * 6

'set dfile 1'
'q dims'
rec = sublin(result,5)
currtime = subwrd(rec,6)

* Note that in the while loop below, we do a display of 
* pmsl with all data values blacked out.  I had to do this
* in order for the switching of the vpage from the 1/6 to
* the 1 degree plot area to work properly.  Don't ask me
* why....

ict = 0
while (ict < 2)

  lastlon = _lon.0
  lastlat = _lat.0
  lastwspd = _windspd.0

  ict = ict + 1
  if (ict = 1)
*   1/6-degree vpage settings....
    ttemp = timeval + 1
    'set dfile 'ttemp
    'set x '_inxstart' '_inxend
    'set y '_inystart' '_inyend
    'set time 'currtime
    'set vpage '_invplft' '_invprgt' '_invpbot' '_invptop
    'set parea '_inpalft' '_inpargt' '_inpabot' '_inpatop
    'set gxout contour'
    'set black -99999999 99999999'
    'set grads off'
    'set mpdraw off'
    'set grid off'
    'd pmsl'
    'set mpdraw on'
    'set grid on'
    xleft  = _gxinf161
    xright = _gxinf162
    ylow   = _gyinf161
    yhi    = _gyinf162
  else
*   1-degree vpage settings....
    'set dfile 1'
    'set x '_xstart' '_xend
    'set y '_ystart' '_yend
    'set time 'currtime
    'set vpage '_outvplft' '_outvprgt' '_outvpbot' '_outvptop
    'set parea '_outpalft' '_outpargt' '_outpabot' '_outpatop
    'set gxout contour'
    'set black -99999999 99999999'
    'set grads off'
    'set mpdraw off'
    'set grid off'
    'd pmsl'
    'set mpdraw on'
    'set grid on'

    'q gxinfo'
    xdum=sublin(result,3)
    ydum=sublin(result,4)
    xl = subwrd(xdum,4)
    xr = subwrd(xdum,6)
    xdiff = xr - xl
    hsiz = xdiff * 0.02
    vsiz = hsiz + 0.015
    cstr = 'Intensity along'
    'set string 1 l 4 0'
    'set strsiz 'hsiz' 'vsiz
    'draw string 0.1 0.32 'cstr

    cstr = 'track line (kts)'
    'set string 1 l 4 0'
    'set strsiz 'hsiz' 'vsiz
    'draw string 0.1 0.12 'cstr
    
    'run cbtrick_int.gs 0.78 0 3.70 0.16'

    xleft  = _gxinfox1
    xright = _gxinfox2
    ylow   = _gxinfoy1
    yhi    = _gxinfoy2
  endif

  ihour = 0
  while (ihour < _maxtrak)

    ihour = ihour + 1
    newlon = _lon.ihour
    newlat = _lat.ihour
    windspd = _windspd.ihour

*   This next statement says that if you are plotting the
*   last position on the forecast track and that last 
*   forecast hour is not 78 or 126, then don't plot anything.
*   The reason for this is that if the model didn't make it
*   to 78h (for a 3-day forecast) or 126h (for a 5-day 
*   forecast), then it stopped tracking short of the final
*   hour, and the very last line in your stats.complete file
*   may contain a position that is extremely whacky (e.g., 
*   Gordon on 2000091812, in the final hour it jumped 10 
*   degrees to the west).  So just skip the final position... 

    if (ihour = _maxtrak)
      if (ihour = 78 | ihour = 126)
*        say ' '
      else
        break
      endif
    endif

    if (_trakopt = nowtrak & ihour > currhour)
      break
    endif

    'query ll2xy 'lastlon' 'lastlat
    xdum  = sublin(result,1)
    xlast = subwrd(xdum,1)
    ylast = subwrd(xdum,2)

    'query ll2xy 'newlon' 'newlat
    xdum = sublin(result,1)
    xnew = subwrd(xdum,1)
    ynew = subwrd(xdum,2)

    oldbound = in
    newbound = in
    if (xlast > xright | xlast < xleft | ylast > yhi | ylast < ylow)
      oldbound = out
    endif
    if (xnew > xright | xnew < xleft | ynew > yhi | ynew < ylow)
      newbound = out
    endif

    if (_trakopt = markpos)
*     This next statement allows us to plot the 0-hour 
*     position.  It does this even though we're on hour 1
*     by plotting the xlast and ylast positions....
      if (ihour = 1 & currhour = 0 & oldbound = in)
        'draw wxsym 41 'xlast' 'ylast' 0.35 2 6'
        break
      endif
*     This next statement plots a hurricane symbol for
*     the current hour being used in the calling function....
      if (ihour = currhour & newbound = in)
        'draw wxsym 41 'xnew' 'ynew' 0.35 2 6'
        break
      else
        continue
      endif
    endif

    if (oldbound = in | newbound = in)
      if (lastwspd < 29)
        'set line 15 1 8'
      endif
      if (lastwspd >= 29 & lastwspd < 35)
        'set line 31 1 8'
      endif
      if (lastwspd >= 35 & lastwspd < 64)
        'set line 32 1 8'
      endif
      if (lastwspd >= 64 & lastwspd < 84)
        'set line 33 1 8'
      endif
      if (lastwspd >= 84 & lastwspd < 97)
        'set line 34 1 8'
      endif
      if (lastwspd >= 97 & lastwspd < 114)
        'set line 35 1 8'
      endif
      if (lastwspd >= 114 & lastwspd < 136)
        'set line 36 1 8'
      endif
      if (lastwspd >= 136)
        'set line 37 1 8'
      endif
      'draw line 'xlast' 'ylast' 'xnew' 'ynew

*      check12 = mod(ihour,12)
*      if (check12 = 0)
      if (ihour = 12 | ihour = 24 | ihour = 36 | ihour = 48 | ihour = 60 | ihour = 72 | ihour = 84 | ihour = 96 | ihour = 108 | ihour = 120)
        'set line 1 1 6'
        'draw mark 3 'xnew' 'ynew' 0.1'
      endif

*     This next if statement is for plotting the 0-hour 
*     position from the tc vitals file....      
      if (ihour = 1)
        'set line 1 1 6'
        'draw mark 3 'xlast' 'ylast' 0.1'
      endif

    endif

    lastlon = newlon
    lastlat = newlat
    lastwspd = windspd

*   If ihour in the loop is equal to the current hour that you 
*   are displaying in the calling function, then plot a 
*   hurricane symbol to indicate the current position....

    if (ihour = currhour & newbound = in)
      if (_dispvar != "Total Precip")
        'draw wxsym 41 'xnew' 'ynew' 0.35 2 6'
      endif

*      check12 = mod(ihour,12)
*      if (check12 = 0)

      if (ihour = 12 | ihour = 24 | ihour = 36 | ihour = 48 | ihour = 60 | ihour = 72 | ihour = 84 | ihour = 96 | ihour = 108 | ihour = 120)
        'set line 1 1 6'
        'draw mark 3 'xnew' 'ynew' 0.1'
      endif

    endif

    if (ihour = 1 & currhour = 0 & oldbound = in)
      if (_dispvar != "Total Precip")
        'draw wxsym 41 'xlast' 'ylast' 0.35 2 6'
      endif
      'set line 1 1 6'
      'draw mark 3 'xlast' 'ylast' 0.1'
    endif

  endwhile

endwhile

return

*--------------------------------------------*
* 
*--------------------------------------------*
function plttitle(timeval) 

'q gxinfo'
xdum=sublin(result,3)
ydum=sublin(result,4)
xl = subwrd(xdum,4)
xr = subwrd(xdum,6)
xdiff = xr - xl
hsiz = xdiff * 0.035
vsiz = hsiz + 0.03

'set vpage off'
'set dfile 1'

'q file 1'
rec = sublin(result,1)
stormenv = subwrd(rec,9)
_stormid = stormenv

'set t 1'
'q dims'
rec = sublin(result,5)
igtime = subwrd(rec,6)
_itime = convtime(igtime)

'set t 'timeval
'q dims'
rec = sublin(result,5)
vgtime = subwrd(rec,6)
vtime = convtime(vgtime)

fhour = (timeval - 1) * 6
if (fhour < 10)
  fhour = "0"%fhour
endif
_pfhour = fhour

fhourm6 = fhour - 6
if (fhourm6 < 10)
  fhourm6 = "0"%fhourm6
endif

xstart = 3.2
ystart = 8.0

cstr = 'GFDL Forecast for '%stormenv
'set string 1 c 4 0'
'set strsiz 'hsiz' 'vsiz
'draw string 'xstart' 'ystart' 'cstr

xstart = 6.3
ystart = 8.0

if (_dispvar = "Total Precip")
  cstr = 'it: '%_itime
else
  cstr = 'it: '%_itime%'  vt: '%vtime%' ('%fhour%'h)'
endif
'set string 1 l 4 0'
'set strsiz 'hsiz' 'vsiz
'draw string 'xstart' 'ystart' 'cstr

plott2 = "no"

if (_dispvar = "u")
  cstr1 = _displev%' mb u-component (knots)'
  cstr2 = ' '
endif
if (_dispvar = "v")
  cstr1 = _displev%' mb v-component (knots)'
  cstr2 = ' '
endif
if (_dispvar = "t")
  cstr1 = _displev%' mb temperature ('%_tempunit%')'
  cstr2 = ' '
endif
if (_dispvar = "sst")
  cstr1 = 'Sea-surface temperature'
  cstr2 = 'and ground temperature ('%_tempunit%')'
  plott2 = "yes"
endif
if (_dispvar = "hgt")
  cstr1 = _displev%' mb geopotential height (m)'
  cstr2 = ' '
endif
if (_dispvar = "rh")
  cstr1 = _displev%' mb relative humidity (%)'
  cstr2 = ' '
endif
if (_dispvar = "ps")
  cstr1 = 'Surface pressure (mb)'
  cstr2 = ' '
endif
if (_dispvar = "pmsl")
  cstr1 = 'Mean sea level pressure (mb)'
  cstr2 = ' '
endif
if (_dispvar = "u35")
  cstr1 = '35m u-component (knots)'
  cstr2 = ' '
endif
if (_dispvar = "v35")
  cstr1 = '35m v-component (knots)'
  cstr2 = ' '
endif
if (_dispvar = "u10")
  cstr1 = '10m u-component (knots)'
  cstr2 = ' '
endif
if (_dispvar = "v10")
  cstr1 = '10m v-component (knots)'
  cstr2 = ' '
endif
if (_dispvar = "prcp")
  if (fhour = 0)
    cstr1 = '0-hour accumulated precip ('%_prcpunit%')'
    cstr2 = ' '
  else
    cstr1 = '6-hour accumulated precip ('%_prcpunit%')'
    cstr2 = 'valid period: '%fhourm6%' - '%fhour%'h'
    plott2 = "yes"
  endif
endif
if (_dispvar = "wvmix")
  cstr1 = _displev%' mb WV mixing ratio (g/kg)'
  cstr2 = ' '
endif
if (_dispvar = "cwmix")
  cstr1 = _displev%' mb CW mixing ratio (g/kg)'
  cstr2 = ' '
endif
if (_dispvar = "rwmix")
  cstr1 = _displev%' mb RW mixing ratio (g/kg)'
  cstr2 = ' '
endif
if (_dispvar = "icmix")
  cstr1 = _displev%' mb ice mixing ratio (g/kg)'
  cstr2 = ' '
endif
if (_dispvar = "totcwat")
  cstr1 = 'Column-integrated cloud water (g/m`a2`n)'
  cstr2 = ' '
endif
if (_dispvar = "totrain")
  cstr1 = 'Column-integrated rain water (g/m`a2`n)'
  cstr2 = ' '
endif
if (_dispvar = "totsnow")
  cstr1 = 'Column-integrated snow (g/m`a2`n)'
  cstr2 = ' '
endif
if (_dispvar = "totcond")
  cstr1 = 'Column-integrated total condensate (g/m`a2`n)'
  cstr2 = ' '
endif
if (_dispvar = "omega")
  cstr1 = _displev%' mb vertical motion (pa/sec)'
  cstr2 = ' '
endif
if (_dispvar = "hrate")
  cstr1 = _displev%' mb diabatic heating (degC/dy)'
  cstr2 = ' '
endif
if (_dispvar = "cd")
  cstr1 = 'Drag coefficient (cd)'
  cstr2 = ' '
endif
if (_dispvar = "ch")
  cstr1 = 'Heat exchange coefficient (ch)'
  cstr2 = ' '
endif
if (_dispvar = "chcd")
  cstr1 = 'Ratio of ch/cd'
  cstr2 = ' '
endif
if (_dispvar = "znot")
  cstr1 = 'Roughness length (znot)'
  cstr2 = ' '
endif
if (_dispvar = "ztherm")
  cstr1 = 'Thermal roughness length (zt)'
  cstr2 = ' '
endif
if (_dispvar = "Vector Wind")
  if (_windunit = "knots")
    cstr1 = _displev%' mb winds (knots)'
  else
    cstr1 = _displev%' mb winds (ms`a-1`n)'
  endif
  cstr2 = ' '
endif
if (_dispvar = "35m Vector Wind")
  if (_windunit = "knots")
    cstr1 = '35m winds (knots)'
  else
    cstr1 = '35m winds (ms`a-1`n)'
  endif
  cstr2 = ' '
endif
if (_dispvar = "10m Vector Wind")
  if (_windunit = "knots")
    cstr1 = '10m winds (knots)'
  else
    cstr1 = '10m winds (ms`a-1`n)'
  endif
  cstr2 = ' '
endif
if (_dispvar = "Relative Vorticity")
  cstr1 = _displev%' mb relative vorticity (s`a-1`n * 10E5)'
  cstr2 = ' '
endif
if (_dispvar = "Forecast Track Only")
  cstr1 = 'Forecast Track'
  cstr2 = ' '
endif
if (_dispvar = "pmsl and 35m winds")
  cstr1 = 'Mean sea level pressure (contours, mb)'
  cstr2 = '35m winds (shaded, knots)'
  plott2 = "yes"
endif
if (_dispvar = "Vertical Shear")
  if (_windunit = "knots")
    cstr1 = _shrlevhi%'-'%_shrlevlo%' mb Vertical Shear (knots)'
  else
    cstr1 = _shrlevhi%'-'%_shrlevlo%' mb Vertical Shear (ms`a-1`n)'
  endif
  cstr2 = ' '
endif
if (_dispvar = "Total Precip")
  cstr1 = _totptitl
  cstr2 = ' '
endif

ystart = ystart - 0.3
'set string 1 l 4 0'
'set strsiz 'hsiz' 'vsiz
'draw string 'xstart' 'ystart' 'cstr1

if (plott2 = "yes")
  ystart = ystart - 0.3
  'set string 1 l 4 0'
  'set strsiz 'hsiz' 'vsiz
  'draw string 'xstart' 'ystart' 'cstr2
endif

return


*----------------------*
*                      *
*----------------------*
function convtime(vtime)

* Use this function to convert a date from the format of, for
* example, 12Z13FEB1998 to 98021312.  The reason I specifically
* choose that hhZddMONYYYY format is because that's what you
* get from the output of 'q dims'.

hh=substr(vtime,1,2)
yy=substr(vtime,9,4)
dd=substr(vtime,4,2)

cmon=substr(vtime,6,3)
if (cmon = 'JAN' | cmon = 'jan'); vplottim=yy%01%dd%hh; endif
if (cmon = 'FEB' | cmon = 'feb'); vplottim=yy%02%dd%hh; endif
if (cmon = 'MAR' | cmon = 'mar'); vplottim=yy%03%dd%hh; endif
if (cmon = 'APR' | cmon = 'apr'); vplottim=yy%04%dd%hh; endif
if (cmon = 'MAY' | cmon = 'may'); vplottim=yy%05%dd%hh; endif
if (cmon = 'JUN' | cmon = 'jun'); vplottim=yy%06%dd%hh; endif
if (cmon = 'JUL' | cmon = 'jul'); vplottim=yy%07%dd%hh; endif
if (cmon = 'AUG' | cmon = 'aug'); vplottim=yy%08%dd%hh; endif
if (cmon = 'SEP' | cmon = 'sep'); vplottim=yy%09%dd%hh; endif
if (cmon = 'OCT' | cmon = 'oct'); vplottim=yy%10%dd%hh; endif
if (cmon = 'NOV' | cmon = 'nov'); vplottim=yy%11%dd%hh; endif
if (cmon = 'DEC' | cmon = 'dec'); vplottim=yy%12%dd%hh; endif

return vplottim

*---------------*
*               *
*---------------*
function mod(i,j)

  z=i/j
  z=int(z)
  a=i-z*j
  a=int(a)

return a

*---------------*
*               *
*---------------*
function int(stuff)

  res = ''
  i = 1
  c = substr(stuff,i,1)
  while (c!='' & ('x'%c)!='x.')
    res = res%c
    i = i + 1
    c = substr(stuff,i,1)
  endwhile

return res

*-----------------------*
*
*-----------------------*
function plotgfdl()

* This just plots the string shown below in the
* bottom right corner of the page.  Note that it
* is called right after the plot for the 1/6 
* degree data, so it is already on the vpage for
* that plot.

  'q gxinfo'
  xdum=sublin(result,3)
  ydum=sublin(result,4)
  xl = subwrd(xdum,4)
  xr = subwrd(xdum,6)
  xdiff = xr - xl
  hsiz = xdiff * 0.02
  vsiz = hsiz + 0.015
  cstr = 'GFDL Hurricane Dynamics Group'
  'set string 1 r 3 0'
  'set strsiz 'hsiz' 'vsiz
  'draw string 10.95 0.1 'cstr

return

*-----------------------*
*
*-----------------------*
function errmsgp()

* This function plots an error message if a user tries
* to plot something without either selecting a storm or
* without selecting a variable.

  say ' '
  say ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
  say ' !!!                                         !!! '
  say ' !!! ERROR: YOU HAVE EITHER NOT YET SELECTED !!! '
  say ' !!!        A STORM, OR YOU HAVE NOT YET     !!! '
  say ' !!!        SELECTED A VARIABLE TO PLOT.     !!! '
  say ' !!!        SELECT STORMS AND VARIABLES WITH !!! '
  say ' !!!        THE BUTTONS AT THE TOP.          !!! '
  say ' !!!                                         !!! '
  say ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
  say ' '

return

*-----------------------*
*
*-----------------------*
function output()

* This function creates an output file of either b&w postscript,
* color postscript or color GIF format, depending on the user 
* input from the MAIN button menu.

  odir = '/net/'%_userid%'/hurplots'

  if (_dispvar = "Forecast Track Only")
    plev = ''
    pvar = 'track'
  endif
  if (_dispvar = "pmsl and 35m winds")
    plev = ''
    pvar = 'pmsl_35m_wind'
  endif
  if (_dispvar = "Vertical Shear")
    plev = _shrlevhi%'-'%_shrlevlo%'mb'
    pvar = 'shear'
  endif
  if (_dispvar = "t")
    plev = _displev%'mb'
    pvar = 'temp'
  endif
  if (_dispvar = "u")
    plev = _displev%'mb'
    pvar = 'ucomp'
  endif
  if (_dispvar = "v")
    plev = _displev%'mb'
    pvar = 'vcomp'
  endif
  if (_dispvar = "hgt")
    plev = _displev%'mb'
    pvar = 'hgt'
  endif
  if (_dispvar = "rh")
    plev = _displev%'mb'
    pvar = 'rh'
  endif
  if (_dispvar = "wvmix")
    plev = _displev%'mb'
    pvar = "wvmix"
  endif
  if (_dispvar = "cwmix")
    plev = _displev%'mb'
    pvar = "cwmix"
  endif
  if (_dispvar = "rwmix")
    plev = _displev%'mb'
    pvar = "rwmix"
  endif
  if (_dispvar = "icmix")
    plev = _displev%'mb'
    pvar = "icmix"
  endif
  if (_dispvar = "omega")
    plev = _displev%'mb' 
    pvar = "omega"
  endif
  if (_dispvar = "hrate")
    plev = _displev%'mb'
    pvar = "hrate"
  endif
  if (_dispvar = "prcp")
    plev = ''
    pvar = '6hprcp'
  endif
  if (_dispvar = "Total Precip")
    plev = ''
    pvar = 'totprcp'
  endif
  if (_dispvar = "pmsl")
    plev = ''
    pvar = 'pmsl'
  endif
  if (_dispvar = "Vector Wind")
    plev = _displev%'mb'
    pvar = 'winds'
  endif
  if (_dispvar = "35m Vector Wind")
    plev = ''
    pvar = '35m_winds'
  endif
  if (_dispvar = "10m Vector Wind")
    plev = ''
    pvar = '10m_winds'
  endif
  if (_dispvar = "Relative Vorticity")
    plev = _displev%'mb'
    pvar = 'zeta'
  endif

  plabel = plev%pvar

  say ' '
  say ' OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO'
  say ' OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO'
  say ' '
  say ' Output file is being written.  Please wait....'
  say ' '

  ifile = odir%'/hur.grads.meta'
  'enable print 'ifile
  'print'
  'disable print'

  if (_hardcopy = "printbw")
    ofile = odir%'/'%_stormid%'.'%plabel%'.'%_itime%'.f'%_pfhour%'.bw.ps'
    '!/net/tpm/grads/linux/gxps -i 'ifile' -o 'ofile
*    '!/net/tpm/grads/1.7.beta.12/gxps -i 'ifile' -o 'ofile
  endif
  if (_hardcopy = "printcl")
    ofile = odir%'/'%_stormid%'.'%plabel%'.'%_itime%'.f'%_pfhour%'.ps'
    '!/net/tpm/grads/linux/gxps -c -i 'ifile' -o 'ofile
  endif
  if (_hardcopy = "printgif")
    ofile = odir%'/'%_stormid%'.'%plabel%'.'%_itime%'.f'%_pfhour%'.gif'
*    '!/net/tpm/grads/1.7.beta.12/gxgif -r -x 757 -y 585 'ifile' -o 'ofile
    '!/net/tpm/grads/linux/gxgif -x 833 -y 644 'ifile' -o 'ofile
  endif
  if (_hardcopy = "printrgif")
    ofile = odir%'/'%_stormid%'.'%plabel%'.'%_itime%'.f'%_pfhour%'.gif'
    '!/net/tpm/grads/linux/gxgif -r -x 833 -y 644 'ifile' -o 'ofile
  endif
  if (_hardcopy = "printpng")
    ofile = odir%'/'%_stormid%'.'%plabel%'.'%_itime%'.f'%_pfhour%'.png'
    'printim 'ofile' x1000 y773 black'
  endif
  if (_hardcopy = "printrpng")
    ofile = odir%'/'%_stormid%'.'%plabel%'.'%_itime%'.f'%_pfhour%'.png'
    'printim 'ofile' x1000 y773 white'
  endif
  say ' '
  say ' Output image has been written to the following file: '
  say ' '
  say ' 'ofile
  say ' '
  say ' OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO'
  say ' OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO'
  say ' '

return

*----------------------*
*                      *
*----------------------*
function testrhbug()

* This function tests if relative humididy is stored as a fraction.
* If it is 1 is returned, otherwise 0 is returned.

  'set gxout stat'
  'set lev 850'
  'd rh'
  
  rec = sublin(result, 8)
  max = subwrd(rec, 5)
    
  if (max <= 2)
    rhbug = 1
  else
    rhbug = 0
  endif
  
return rhbug
